// ============================================================================
// $Id: ScriptParser.java,v 1.3 2009/06/28 00:02:30 davidahall Exp $
// Copyright (c) 2007  David A. Hall
// ============================================================================
// The contents of this file are subject to the Common Development and
// Distribution License (CDDL), Version 1.0 (the License); you may not
// use this file except in compliance with the License.
//
// From time to time, the license steward (initially Sun Microsystems,
// Inc.), and may publish revised and/or new versions of this License.
// You may not use, distribute, or otherwise make this file available
// under subsequent versions of the License.
//
// You should have received a copy of the the License along with this
// file: if not, a copy of the License is available at
//
// http://www.sun.com/cddl/cddl.html
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// ============================================================================

package net.sf.jga.scripting;


import javax.script.ScriptContext;

import net.sf.jga.fn.Generator;
import net.sf.jga.parser.FunctorRef;
import net.sf.jga.parser.GeneratorRef;
import net.sf.jga.parser.JFXGParser;
import net.sf.jga.parser.ParseException;

/**
 * ScriptParser.java
 *
 * <p>
 * Copyright &copy; 2007  David Hall
 * @author <a href="mailto:davidahall@users.sf.net">David Hall</a>
 */

public class ScriptParser extends JFXGParser {
    private ScriptContext context;
    
    public ScriptParser (){
    }

    public ScriptContext getScriptContext() {
        return context;
    }

    public void setScriptContext(ScriptContext context) {
        this.context = context;
    }
    
    @SuppressWarnings("serial")
    // The anonymous Generator doesn't have a serial ID
    protected FunctorRef<?,?> reservedWord(final String name) throws ParseException {
        final Object value = context.getAttribute(name);
        if (value == null)
            return null;

        final Class<?> type = value.getClass();
        
        return new GeneratorRef/*<Object>*/(new Generator<Object>(){
            @Override
            public Object fn() {
                Object result = context.getAttribute(name);
//                if (result == null) {
//                    // warn?!?!? -- this could be source of NPX's later
//                }
//                else if (value.getClass().isInstance(result)) {
//                    throw new UncheckedParseException("Runtime type changed since script compiled: expected "
//                            +type+"; runtime type was "+result.getClass());
//                }
                return result;
            }
        }, type);
    }
}
