/* Generated By:JavaCC: Do not edit this line. JFXGParser.java */
package net.sf.jga.parser;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringBufferInputStream;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.NoSuchElementException;
import java.util.Set;
import net.sf.jga.algorithms.Summarize;
import net.sf.jga.fn.*;
import net.sf.jga.fn.adaptor.*;
import net.sf.jga.fn.arithmetic.*;
import net.sf.jga.fn.comparison.*;
import net.sf.jga.fn.logical.*;
import net.sf.jga.fn.property.*;
import net.sf.jga.fn.string.*;
import net.sf.jga.util.ComparableComparator;

/**
 * Parser that converts JFXG strings into functors.  The parser is <b>not</b> safe to be
 * used concurrently by multiple threads.
 * <p>
 * Copyright &copy; 2004-2005  David A. Hall
 */
 @SuppressWarnings({"unchecked","unused","deprecation","serial"})
public class JFXGParser implements FunctorParser, JFXGParserConstants {
    public static void main(String args[]) {
        JFXGParser fnp = new JFXGParser();

        try {
            FunctorRef ref = fnp.Functor(fnp._baseContext.copy());
        }
        catch (Exception x) {
            System.out.println(x.getMessage());
            x.printStackTrace();
        }
    }

    // When I started, the parser could only create Generators, UnaryFunctors, and BinaryFunctors.  
    // I'd set aside 'x' and 'y' as the reserved names of the two arguments.  At first, I thought
    // that positional arguments would take the form "{0}","{1}","{2}", etc, with "x" and "y" 
    // honored as synonyms for "{0}" and "{1}" for compatability.  We're keeping the predefined
    // 'x' and 'y' available when used from the old entry points (ie, parseUnary, et al).  In
    // parseFunctor, there will be no predefined variable names.

    // The predefined names of the supported unknowns.  There can be only two, at this point.
    static public final String ARG_NAME[] = {"x","y"};

    private ParserContext _baseContext = new ParserContext();

    private FunctorRef _lastFunctorRef;

    static private Map javalang = JavaLangResources.getMap();


    // ref to a functor that converts chars to int.  This is used to support
    // addition expressions with chars.
    static private UnaryFunctorRef charToInt =
        new UnaryFunctorRef(new ConstructUnary(Integer.TYPE,Integer.class)
                             .compose(new InvokeNoArgMethod(Character.class,"charValue")),
                            Character.class, "?", Integer.class);


    // Constructors that JavaCC doesn't create with the current options
    public JFXGParser() {
        this(new InputStreamReader(System.in));
    }


    //======================
    // Parser Configuration
    //======================

    /**
     * Imports the given package (by name) into the parser.
     */
    public void importPackage(String pkgName) {
        _baseContext.importPackage(pkgName);
    }


    /**
     * Removes information about the given package.
     */
    public void deportPackage(String pkgName) {
        _baseContext.deportPackage(pkgName);
    }


    /**
     * Imports the given class into the parser.  The class will not need to be
     * fully qualified for use in expressions.  This will replace any existing
     * imported class that happens to have the same name.
     */
    public void importClass(Class<?> clasz) {
        _baseContext.importClass(clasz);
    }


    /**
     * Imports the given class into the parser under the given alias.  The alias
     * may be used in place of the fully qualified name of the class hereafter.
     * This will replace any existing imported class associated with the alias.
     */
    public void importClass(String alias, Class<?> clasz) {
        _baseContext.importClass(alias, clasz);
    }


    /**
     * Removes information about the class imported under the given name.
     */
    public void deportClass(String alias) {
        _baseContext.deportClass(alias);
    }


    /**
     * Returns the Class object that represents the given name.
     */
    public Class<?> getImportedClass(String alias) {
        Class<?> c = (Class) javalang.get(alias);
        if (c != null)
            return c;

        return _baseContext.getImportedClass(alias);
    }


    /**
     * Returns true if the class is imported into the default parser context.
     */
    public boolean isClassImported(Class<?> clasz) {
        String simpleName = ParserUtils.getSimpleName(clasz);
        return javalang.get(simpleName) != null || findClass(_baseContext, simpleName) != null;
    }


    /**
     * Imports all of the static public methods and members in the given class.
     */
    public void importStatics(Class<?> clasz) {
        _baseContext.importStatics(clasz);
    }


    /**
     * Imports the given static member.  The member will not need to be qualified
     * with its classname for use in expressions.
     * @throws java.lang.NoSuchFieldException if the named field does not exist
     * @throws java.lang.IllegalArgumentException if the named field is not static
     */
    public void importField(Class<?> clasz, String name) throws NoSuchFieldException {
        _baseContext.importField(clasz, name);
    }

    /**
     * Imports the given static member.  The member will not need to be qualified
     * with its classname for use in expressions.
     * @throws java.lang.IllegalArgumentException if the field is not static
     */
    public void importField(Field field) throws IllegalArgumentException {
        _baseContext.importField(field);
    }

    /**
     * Returns the imported field with the given name, or null if no such field has
     * been imported.
     */
    public Field getImportedField(String name) {
        return _baseContext.getImportedField(name);
    }

    /**
     * Imports the given static method(s).  
     * @throws java.lang.NoSuchMethodException if the named method does not exist, or if
     * it/they is/are not static
     */
    public void importMethod(Class<?> clasz, String name) throws NoSuchMethodException {
        _baseContext.importMethod(clasz, name);
    }

    /**
     * Imports a static method into the parser.  The method will not need to be
     * qualified with its classname for use in expressions.  Multiple methods
     * may be imported with the same name: the first best fit will be used when
     * the method name is used.
     * @throws java.lang.NoSuchMethodException if the named method does not exist
     * @throws java.lang.IllegalArgumentException if the named method is not static
     */
    public void importMethod(Method meth) {
        _baseContext.importMethod(meth);
    }

    /**
     * Imports a static method into the parser under the given name.  The method
     * will not need to be qualified with its classname for use in expressions.
     * Multiple methods may be imported with the same name: the first best fit
     * will be used when the method name is used.
     * @throws java.lang.IllegalArgumentException if the method is not static
     */
    public void importMethod(String name, Method meth) {
        _baseContext.importMethod(name, meth);
    }


    /**
     * Returns a list of methods with the given name
     */
    public Method[] getImportedMethods(String name) {
        return _baseContext.getImportedMethods(name);
    }


    /**
     * Imports the static methods of the jga algorithm and functor builder classes.
     * The following classes are statically imported, as if specified via a wildcard
     * static import statement:
     * <ul>
     * <li>{@link net.sf.jga.algorithms.Compare}</li>
     * <li>{@link net.sf.jga.algorithms.Filter}</li>
     * <li>{@link net.sf.jga.algorithms.Find}</li>
     * <li>{@link net.sf.jga.algorithms.Flatten}</li>
     * <li>{@link net.sf.jga.algorithms.Merge}</li>
     * <li>{@link net.sf.jga.algorithms.Reverse}</li>
     * <li>{@link net.sf.jga.algorithms.Sort}</li>
     * <li>{@link net.sf.jga.algorithms.Summarize}</li>
     * <li>{@link net.sf.jga.algorithms.Transform}</li>
     * <li>{@link net.sf.jga.algorithms.Unique}</li>
     * <li>{@link net.sf.jga.fn.adaptor.AdaptorFunctors}</li>
     * <li>{@link net.sf.jga.fn.arithmetic.ArithmeticFunctors}</li>
     * <li>{@link net.sf.jga.fn.comparison.ComparisonFunctors}</li>
     * <li>{@link net.sf.jga.fn.logical.LogicalFunctors}</li>
     * <li>{@link net.sf.jga.fn.property.PropertyFunctors}</li>
     * <li>{@link net.sf.jga.fn.string.StringFunctors}</li>
     * </ul>
     */

    public void importJGA() {
        for(int i = 0; i < jgaClasses.length; ++i) {
            importStatics(jgaClasses[i]);
        }
    }

    private Class<?>[] jgaClasses = {
        net.sf.jga.algorithms.Compare.class,
        net.sf.jga.algorithms.Filter.class,
        net.sf.jga.algorithms.Flatten.class,
        net.sf.jga.algorithms.Find.class,
        net.sf.jga.algorithms.Merge.class,
        net.sf.jga.algorithms.Sort.class,
        net.sf.jga.algorithms.Reverse.class,
        net.sf.jga.algorithms.Summarize.class,
        net.sf.jga.algorithms.Transform.class,
        net.sf.jga.algorithms.Unique.class,
        net.sf.jga.fn.adaptor.AdaptorFunctors.class,
        net.sf.jga.fn.arithmetic.ArithmeticFunctors.class,
        net.sf.jga.fn.comparison.ComparisonFunctors.class,
        net.sf.jga.fn.logical.LogicalFunctors.class,
        net.sf.jga.fn.property.PropertyFunctors.class,
        net.sf.jga.fn.string.StringFunctors.class
    };

    /**
     * Imports the static methods of the specified jga class.   It isn't necessary
     * to fully qualify the classname (although it works fine if you do).
     */

    public void importJGA(String className) {
        UnaryFunctor eqClassName = new CompareProperty(Class.class, "getName", className);
        UnaryFunctor eqShortName = new CompareProperty(Class.class, "getShortName", className);
        UnaryFunctor eqNameOrShortName = new LogicalOr().compose(eqClassName, eqShortName);
        Class<?> clasz = (Class) Summarize.lookup(jgaClasses, eqNameOrShortName);
        if (clasz != null) {
            importStatics(clasz);
        }
    }

    /**
     * Binds the object to which 'this' refers    
     */
    public void bindThis(Object thisBinding) {
        _baseContext.bindThis(thisBinding);
    }


    /**
     * Returns the current object to which 'this' refers
     */
    protected Object getBoundObject() {
        return _baseContext.getBoundObject();
    }


    /**
     * Enables/Disables the interpretation of undecorated decimal literals
     * as BigDecimals.  When true, an undecorated number containing a
     * decimal, for example <tt>1.50</tt> is interpreted as a BigDecimal
     * literal.  When false, the same token is interpreted as a Double, as
     * is the case in standard java
     */
    public void setUndecoratedDecimal(boolean flag) { _baseContext.setUndecoratedDecimal(flag); }


    /**
     * When true, an undecorated number containing a
     * decimal, for example <tt>1.50</tt> is interpreted as a BigDecimal
     * literal.  When false, the same token is interpreted as a Double, as
     * is the case in standard java
     */
    public boolean isUndecoratedDecimal() { return _baseContext.isUndecoratedDecimal(); }


    /**
     * Registers a type-coercion rule that will promote values of the from type to
     * values of the to type for use in expressions.
     */
    public void addPromotionRule(Class<?> fromType, Class<?> toType, UnaryFunctor converter) {
        _baseContext.addPromotionRule(fromType, toType, converter);
    }


    /**
     * Removes the type-coercion rule (if any) that would have promoted values of the
     * from type to values of the to type for use in expressions.
     */
    public void removePromotionRule(Class<?> fromType, Class<?> toType) {
        _baseContext.removePromotionRule(fromType, toType);
    }

    //======================
    // Parser Entry Points
    //======================

    /**
     * Parses the string to create a Generator.
     */
    public Functor<?> parseFunctor(String str) throws ParseException {
        ReInit(new StringBufferInputStream(str));
        return parseFunctor(_baseContext.copy()).getFunctor();
    }


    /**
     * Parses the string to create a Generator.
     */
    public Generator<?> parseGenerator(String str) throws ParseException {
        ReInit(new StringBufferInputStream(str));
        return parseGenerator();
    }


    /**
     * Parses the contents of the current input to create a Generator
     */
    public Generator<?> parseGenerator() throws ParseException {
        return parseGeneratorRef().getFunctor();
    }


    /**
     * Parses the contents of the current input to create a Generator
     */
    protected GeneratorRef<?> parseGeneratorRef() throws ParseException {
        try {
            FunctorRef<?,?> ref = parseFunctor(_baseContext.copy());
            if (ref instanceof GeneratorRef)
                return (GeneratorRef) ref;
        }
        catch (ParseException x) {
            throw x;
        }
        catch (Throwable x) {
            ParseException px = new ParseException(x.getMessage());
            px.initCause(x);
            throw px;
        }

        throw new ParseException("Invalid number of arguments");
    }


    /**
     * Parses the string to create a UnaryFunctor that takes an argument of the
     * given type.
     */
    public <T> UnaryFunctor<T,?> parseUnary(String str, Class<T> argType) throws ParseException {
        ReInit (new StringBufferInputStream(str));
        return parseUnary(argType);
    }


    /**
     * Parses the current input to create a UnaryFunctor that takes an argument of the
     * given type.
     */
    public <T> UnaryFunctor<T,?> parseUnary(Class<T> argType) throws ParseException {
        return parseUnaryRef(argType).getFunctor();
    }


    /**
     * Parses the current input to create a UnaryFunctor that takes an argument of the
     * given type.
     */
    protected <T> UnaryFunctorRef<T,?> parseUnaryRef(Class<T> argType) throws ParseException {
        ParserContext context = _baseContext.copy();
        context.declareArgument(0, ARG_NAME[0], argType);

        try {
            FunctorRef<?,?> ref = parseFunctor(context);
            return ensureUnary(ref, argType, ARG_NAME[0]);
        }
        catch(ParseException x) {
            throw x;
        }
        catch(Throwable x) {
            ParseException px = new ParseException(x.getMessage());
            px.initCause(x);
            throw px;
        }
    }


    /**
     * Parses the string to create a BinaryFunctor that takes arguments of the
     * given types.
     */
    public <T1,T2> BinaryFunctor<T1,T2,?> parseBinary(String str, Class<T1> arg1Type, Class<T2> arg2Type)
            throws ParseException
    {
        ReInit (new StringBufferInputStream(str));
        return parseBinary(arg1Type, arg2Type);
    }


   /**
     * Parses the current input to create a BinaryFunctor that takes arguments of the
     * given types.
     */
    public <T1,T2> BinaryFunctor<T1,T2,?> parseBinary(Class<T1> arg1Type, Class<T2> arg2Type)
            throws ParseException
    {
        return parseBinaryRef(arg1Type, arg2Type).getFunctor();
    }


    /**
     * Parses the current input to create a BinaryFunctor that takes arguments of the
     * given types.
     */
    protected <T1,T2> BinaryFunctorRef<T1,T2,?> parseBinaryRef(Class<T1> arg1Type, Class<T2> arg2Type)
            throws ParseException
    {
        ParserContext context = _baseContext.copy();
        context.declareArgument(0, ARG_NAME[0], arg1Type);
        context.declareArgument(1, ARG_NAME[1], arg2Type);

        try {
            FunctorRef<?,?> ref = parseFunctor(context);
            return ensureBinary(ref, arg1Type, arg2Type);
        }
        catch(ParseException x) {
            throw x;
        }
        catch(Throwable x) {
            ParseException px = new ParseException(x.getMessage());
            px.initCause(x);
            throw px;
        }
    }


    /**
     * Parses a functor from the input stream, ensuring that it returns an Object
     * (ie, if the expression would generally return a primitive, the functor will
     * be bound within a boxing functor).
     */
    protected FunctorRef<?,?> parseFunctor(ParserContext context) throws ParseException {
        FunctorRef<?,?> fn = Functor(context);
        Class<?> expType = fn.getReturnType();
        if (expType.isPrimitive()) {
            fn = boxUnboxFunctor(ParserUtils.getBoxedType(expType), fn);
            if (fn == null ){
                String msg = "Internal error: no boxed functor registered for type "+ expType;
                throw new ParseException(msg);
            }
        }

        _lastFunctorRef = fn;
        return fn;
    }


    /**
     * Returns the type of object returned by the last functor parsed.
     * @throws IllegalStateException if the parser has not been used or if 
     * parsing the last functor resulted in an exception being thrown.
     */
    public Class<?> getReturnType() {
        if (_lastFunctorRef == null)
            throw new IllegalStateException();

        return _lastFunctorRef.getReturnType();
    }

    //======================
    // Static entry points
    //======================

    // global instance
    static private JFXGParser _instance;

    /**
     * Returns a globally accessible default instance of a JFXGParser.  Settings of this
     * instance cannot be changed from their defaults: attempts to change any of the
     * default settings of configurable values will be silently ignored.
     */
    static public synchronized JFXGParser getInstance() {
        if (_instance == null) {
            _instance = new JFXGParser() {
                    public void setUndecoratedDecimal(boolean flag) {
                        throw new UnsupportedOperationException();
                    }
                    public void importPackage(String pkgName) {
                        throw new UnsupportedOperationException();
                    }
                    public void importClass(Class<?> clasz) {
                        throw new UnsupportedOperationException();
                    }
                    public void importClass(String alias, Class<?> clasz) {
                        throw new UnsupportedOperationException();
                    }
                    public void deportClass(String alias) {
                        throw new UnsupportedOperationException();
                    }
                    public void importStatics(Class<?> clasz) {
                        throw new UnsupportedOperationException();
                    }
                    public void importField(Class<?> clasz, String name) {
                        throw new UnsupportedOperationException();
                    }
                    public void importField(Field field) {
                        throw new UnsupportedOperationException();
                    }
                    public void importMethod(Class<?> clasz, String name) {
                        throw new UnsupportedOperationException();
                    }
                    public void importMethod(Method meth) {
                        throw new UnsupportedOperationException();
                    }
                    public void importMethod(String name, Method meth) {
                        throw new UnsupportedOperationException();
                    }
                    public void bindThis(Object binding) {
                        throw new UnsupportedOperationException();
                    }
                    public void addPromotionRule(Class<?> from, Class<?> to, UnaryFunctor converter) {
                        throw new UnsupportedOperationException();
                    }
                    public void removePromotionRule(Class<?> fromType, Class<?> toType) {
                        throw new UnsupportedOperationException();
                    }
                };
        }

        return _instance;
    }


    /**
     * Parses the string to create a Generator.
     */
    static public Generator<?> parse(String str) throws UncheckedParseException {
        try {
            return getInstance().parseGenerator(str);
        }
        catch(ParseException x) {
            throw new UncheckedParseException(x);
        }
    }


    /**
     * Parses the string to create a UnaryFunctor that takes an argument of the
     * given type.
     */
    static public <T> UnaryFunctor<T,?> parse(String str, Class<T> argType) throws UncheckedParseException {
        try {
            return (UnaryFunctor<T,?>) getInstance().parseUnary(str, argType);
        }
        catch(ParseException x) {
            throw new UncheckedParseException(x);
        }
    }


    /**
     * Parses the string to create a BinaryFunctor that takes arguments of the
     * given types.
     */
    static public <T1,T2> BinaryFunctor<T1,T2,?> parse(String str, Class<T1> arg1Type, Class<T2> arg2Type)
            throws UncheckedParseException
    {
        try {
            return getInstance().parseBinary(str, arg1Type, arg2Type);
        }
        catch(ParseException x) {
            throw new UncheckedParseException(x);
        }
    }

    //======================
    // Extension Points
    //======================

    /**
     * Allows for (not necessarily constant) values to be added to the grammar
     */
    protected FunctorRef<?,?> reservedWord(String name) throws ParseException {
        return null;
    }


    /**
     * Allows for (not necessarily constant) predefined fields to be added to the grammar
     */
    protected FunctorRef<?,?> reservedField(FunctorRef<?,?> prefix, String name) throws ParseException {
        return null;
    }


    /**
     * Allows for function-style names to be added to the grammar.
     */
    protected FunctorRef<?,?> reservedFunction(String name, FunctorRef<?,?>[] args) throws ParseException{
        return null;
    }


    /**
     * Allows for alternate strategies for resolving methods
     */
    protected BinaryFunctorRef<?,?,?> reservedMethod(FunctorRef<?,?> prefix, String name, Class<?>[] types)
            throws ParseException
    {
        return null;
    }

    /**
     * Return a functor that performs promotion on the functor (if necessary
     * and possible) to the given type.  If the functor is already of the same type, it is
     * returned.  If the conversion is not possible, returns null.
     */
    protected /*<R>*/ FunctorRef/*<R,Functor<R>>*/ promote(FunctorRef/*<?,Functor<?>>*/ ref, Class/*<R>*/ type) throws ParseException {
        FunctorRef/*<R,Functor<R>>*/ boxed = boxUnboxFunctor(type, ref);
        if (boxed != null)
            ref = boxed;

        Class<?> refType = ref.getReturnType();
        if (type.isAssignableFrom(refType))
            return ref;

        UnaryFunctor<?,?> converter = _baseContext.getPromotionRule(refType, type);
        if (converter != null) {
            UnaryFunctorRef<?,?> converted = new UnaryFunctorRef(converter, refType, "", type);
            return bindUnaryFn(converted, ref);
        }

        return promoteExt(ref, type);
    }

    /**
     * Return a functor that performs promotion on the functor (if necessary
     * and possible) to the given type.  If the conversion is not possible, returns null.
     */
    protected <R> FunctorRef<R,Functor<R>> promoteExt(FunctorRef<?,Functor<?>> ref, Class<R> type) {
        return null;
    }


    /**
     */
    protected FunctorRef demote(FunctorRef ref, Class type) throws ParseException {
        Class<?> refType = ref.getReturnType();
        UnaryFunctor<?,?> converter = _baseContext.getDemotionRule(refType, type);
        if (converter != null) {
            UnaryFunctorRef<?,?> converted = new UnaryFunctorRef(converter, refType, "", type);
            return bindUnaryFn(converted, ref);
        }

        return demoteExt(ref, type);
    }

    /**
     * Return a functor that performs promotion on the functor (if necessary
     * and possible) to the given type.  If the conversion is not possible, returns null.
     */
    protected <R> FunctorRef<R,Functor<R>> demoteExt(FunctorRef<?,Functor<?>> ref, Class<R> type) {
        return null;
    }


    /**
     * Find and return a class to which both arguments of a binary operation may be promoted,
     * if any.  If no such class exists, return null.
     */
    protected Class<?> findCommonPromotion(Class<?> root, Class<?> ltype, Class<?> rtype) {
        // make sure they're both references
        ltype = ParserUtils.getBoxedType(ltype);
        rtype = ParserUtils.getBoxedType(rtype);

        // if they're not derived from root, then throw an exception
        if (! (root.isAssignableFrom(ltype) && root.isAssignableFrom(rtype))) {
            return null;
        }

        // Simplest case -- the two arguments are already of the same type
        if (ltype == rtype)
            return ltype;

        // See if one is a base class of the other
        if (ltype.isAssignableFrom(rtype))
            return ltype;

        if (rtype.isAssignableFrom(ltype))
            return rtype;

        // Next, see if the left argument can be promoted to the type of the right
        if (_baseContext.getPromotionRule(ltype, rtype) != null) {
            return rtype;
        }

        // ... If not, check the converse
        if (_baseContext.getPromotionRule(rtype, ltype) != null){
            return ltype;
        }

        return null;
    }

    //======================
    // Boxing/Unboxing
    //======================

    static private Map boxFunctors = new HashMap();
    static private Map unboxFunctors = new HashMap();

    static {
            boxFunctors.put(Boolean.TYPE,
                            new InvokeMethod(Boolean.class, "valueOf", new Class[]{Boolean.TYPE})
                                .bind1st(null).compose(new ArrayUnary()));
            boxFunctors.put(Character.TYPE, new ConstructUnary(Character.TYPE, Character.class));
            boxFunctors.put(Byte.TYPE, new ConstructUnary(Byte.TYPE, Byte.class));
            boxFunctors.put(Short.TYPE,new ConstructUnary(Short.TYPE, Short.class));
            boxFunctors.put(Integer.TYPE,new ConstructUnary(Integer.TYPE, Integer.class));
            boxFunctors.put(Long.TYPE,new ConstructUnary(Long.TYPE, Long.class));
            boxFunctors.put(Float.TYPE,new ConstructUnary(Float.TYPE, Float.class));
            boxFunctors.put(Double.TYPE,new ConstructUnary(Double.TYPE, Double.class));
            boxFunctors.put(Void.TYPE,new ConstantUnary(null)); // Huh?  Check this. (TODO)

            unboxFunctors.put(Boolean.class, new InvokeNoArgMethod(Boolean.class, "booleanValue"));
            unboxFunctors.put(Character.class, new InvokeNoArgMethod(Character.class,"charValue"));
            unboxFunctors.put(Byte.class, new InvokeNoArgMethod(Byte.class,"byteValue"));
            unboxFunctors.put(Short.class, new InvokeNoArgMethod(Short.class,"shortValue"));
            unboxFunctors.put(Integer.class, new InvokeNoArgMethod(Integer.class,"intValue"));
            unboxFunctors.put(Long.class, new InvokeNoArgMethod(Long.class,"longValue"));
            unboxFunctors.put(Float.class, new InvokeNoArgMethod(Float.class,"floatValue"));
            unboxFunctors.put(Double.class, new InvokeNoArgMethod(Double.class,"doubleValue"));
    }

    /**
     * Returns a Functor that 'boxes' the given primitive type, or null if the given type is
     * not a primitive.
     */
    static public UnaryFunctor<?,?> getBoxFunctor(Class<?> primitive) {
        return (UnaryFunctor<?,?>)boxFunctors.get(primitive);
    }


    /**
     * Returns a Functor that 'unboxes' the given reference type, or null if the given
     * type is not a reference to a primitive
     */
    static public UnaryFunctor<?,?> getUnboxFunctor(Class<?> reference) {
        return (UnaryFunctor<?,?>)unboxFunctors.get(reference);
    }


    /**
     * When the class that we need is the boxed (or unboxed) form of the return type of the
     * given functor, then wrap the functor in a boxing/unboxing functor to make the change
     * at runtime.  If the class that we need is not the class that were given nor is it
     * a boxed/unboxed form, return null;
     */
    protected <R> FunctorRef/*<R,Functor<R>>*/ boxUnboxFunctor(Class<R> reqType, FunctorRef<?,?> ref)
            throws ParseException {
        // First, check to see if boxing/unboxing is necessary: if the reference is a null
        // reference, or if it is already of the required type
        if (isNull(ref))
            return /*(FunctorRef<R,Functor<R>>)*/ ref;

        Class<?> argType = ref.getReturnType();
        if (reqType.isAssignableFrom(argType))
            return /*(FunctorRef<R,Functor<R>>)*/ ref;

        // If the required type is a primitive, then see if the return
        // type can be unboxed to yield it
        if (reqType.isPrimitive() && reqType == ParserUtils.getUnboxedType(argType)) {
            UnaryFunctor<?,?> uf = getUnboxFunctor(argType);
            UnaryFunctorRef<?,?> unboxed = new UnaryFunctorRef(uf, argType, "", reqType);
            return bindUnaryFn(unboxed, ref);
        }

        // If the return type is a primitive, then see if it's boxed
        // form is the required type
        if (argType.isPrimitive() && reqType.isAssignableFrom(ParserUtils.getBoxedType(argType))) {
            UnaryFunctor<?,?> uf = getBoxFunctor(argType);
            UnaryFunctorRef<?,?> boxed = new UnaryFunctorRef(uf, argType, "", reqType);
            return bindUnaryFn(boxed, ref);
        }

        return null;
    }

    /**
     * Returns true if the functorref is a string constant
     */
    private boolean isStringConst(FunctorRef<?,?> ref) throws ParseException {
        return ref.isConstant() && ref.getReturnType().equals(String.class);
    }

    /**
     * Returns true if the functorref is a null reference, ie, the constant 'null'
     */
    private boolean isNull(FunctorRef<?,?> ref) throws ParseException {
        return ref.isConstant() && ((GeneratorRef) ref).getFunctor().fn() == null;
    }


    // A Stable functor is one that will always return the same value for the same set
    // of inputs.   These functors are safe to evaluate during the parse if all of the
    // inputs that will be passed to them are CONSTANT: the result will be a CONSTANT

    static private Set stableFunctors = new HashSet();
    static {
        stableFunctors.add(BitwiseAnd.class);
        stableFunctors.add(BitwiseNot.class);
        stableFunctors.add(BitwiseOr.class);
        stableFunctors.add(BitwiseXor.class);
        stableFunctors.add(Cast.class);
        stableFunctors.add(DefaultFormat.class);
        stableFunctors.add(Divides.class);
        stableFunctors.add(EqualTo.class);
        stableFunctors.add(Greater.class);
        stableFunctors.add(GreaterEqual.class);
        stableFunctors.add(Identity.class);
        stableFunctors.add(InstanceOf.class);
        stableFunctors.add(Less.class);
        stableFunctors.add(LessEqual.class);
        stableFunctors.add(LogicalAnd.class);
        stableFunctors.add(LogicalNot.class);
        stableFunctors.add(LogicalOr.class);
        stableFunctors.add(Minus.class);
        stableFunctors.add(Modulus.class);
        stableFunctors.add(Multiplies.class);
        stableFunctors.add(Negate.class);
        stableFunctors.add(NotEqualTo.class);
        stableFunctors.add(Plus.class);
        stableFunctors.add(ShiftLeft.class);
        stableFunctors.add(ShiftRight.class);
        stableFunctors.add(UnsignedShiftRight.class);
        stableFunctors.add(ValueOf.class);
    }

    private boolean isStable(UnaryFunctor<?,?> fn) {
        return stableFunctors.contains(fn.getClass());
    }

    private boolean isStable(BinaryFunctor<?,?,?> fn) {
        return stableFunctors.contains(fn.getClass());
    }

    //======================
    // Functor Assembly
    //======================

    /**
     */

    private FunctorRef bindUnaryFn (UnaryFunctorRef uf, FunctorRef arg) throws ParseException {
        // Check the argument to ensure that it produces what the outer functor needs
        // boxing/unboxing the return type if necessary.
        FunctorRef boxedArg = boxUnboxFunctor(uf.getArgType(0), arg);
        if (boxedArg == null) {
            String err = "{0} requires arguments of {1} : received {2}";
            String msg = MessageFormat.format(err, new Object[]{ uf.getFunctor(),uf.getArgType(0),
                                                                 arg.getReturnType()} );
            throw new ParseException(msg);
        }

        if (boxedArg.isConstant()) {
            Object val = ((GeneratorRef) boxedArg).getFunctor().fn();
            if (isStable(uf.getFunctor()))
                return new GeneratorRef(new Constant(uf.getFunctor().fn(val)), uf.getReturnType());
            else
                return new GeneratorRef(uf.getFunctor().bind(val), uf.getReturnType());
        }
        else if (boxedArg.getNumberArgs() == 0) {
            Generator gen = ((GeneratorRef) boxedArg).getFunctor();
            return new GeneratorRef(uf.getFunctor().generate(gen), uf.getReturnType());
        }
        else if (boxedArg.getNumberArgs() == 1) {
                UnaryFunctor argFn = ((UnaryFunctorRef) boxedArg).getFunctor();
                return new UnaryFunctorRef(uf.getFunctor().compose(argFn), boxedArg.getArgType(0), "",
                                           uf.getReturnType());
        }

        throw new ParseException("Cannot bind ["+uf+"] with arg ["+arg+"]");
    }


    /**
     */
    private FunctorRef bindBinaryOperation(Class<?> root, ArithmeticOperator operator, FunctorRef lop, FunctorRef rop)
            throws ParseException
    {
        Class<?> ltype = lop.getReturnType();
        Class<?> rtype = rop.getReturnType();
        Class<?> common = findCommonPromotion(root, ltype, rtype);
        if (common != null) {
            lop = promote(lop, common);
            rop = promote(rop, common);
        }

        if (common == null || lop == null || rop == null) {
            String fmt = "operator ''{0}'' requires arguments of type {1}: received {2} and {3}";
            String msg = MessageFormat.format(fmt, operator, root, ltype, rtype);
            throw new ParseException(msg);
        }

        if (isIntegralOperation(operator)){
            if (! isIntegralType(ltype) || ! isIntegralType(rtype)) {
                String fmt = "operator ''{0}'' requires integral arguments: received {1} and {2}";
                String msg = MessageFormat.format(fmt, operator, ltype, rtype);
                throw new ParseException(msg);
            }
        }

        BinaryFunctor bf;
        switch(operator) {
        case EQUAL:
            return bindBinaryFn(new EqualTo(), Boolean.class, lop, rop);
        case NOTEQUAL:
            return bindBinaryFn(new NotEqualTo(), Boolean.class, lop, rop);
        case LESS:
            return bindBinaryFn(new Less(getComparator(common)), Boolean.class, lop, rop);
        case LESSEQUAL:
            return bindBinaryFn(new LessEqual(getComparator(common)), Boolean.class, lop, rop);
        case GREATER:
            return bindBinaryFn(new Greater(getComparator(common)), Boolean.class, lop, rop);
        case GREATEREQUAL:
            return bindBinaryFn(new GreaterEqual(getComparator(common)), Boolean.class, lop, rop);
        case PLUS:
            return bindBinaryFn(new Plus(common), common, lop, rop);
        case MINUS:
            return bindBinaryFn(new Minus(common), common, lop, rop);
        case TIMES:
            return bindBinaryFn(new Multiplies(common), common, lop, rop);
        case DIVIDES:
            return bindBinaryFn(new Divides(common), common, lop, rop);
        case MODULUS:
            return bindBinaryFn(new Modulus(common), common, lop, rop);
        default:
            throw new IllegalArgumentException("Unknown binary operation  '"+operator+"'");
        }
    }


    /**
     */
    private boolean isIntegralOperation(ArithmeticOperator operator) {
        return operator == ArithmeticOperator.MODULUS;
    }

    /**
     */
    private boolean isIntegralType(Class<?> type){
        Class boxedType = ParserUtils.getBoxedType(type);
        return ArithmeticFactory.getArithmetic(boxedType) instanceof IntegerArithmetic;
    }


    /**
     */
    private <R> FunctorRef<R,Functor<R>>
    bindBinaryFn(BinaryFunctor<?,?,R> bf, Class<R> fType, FunctorRef<?,?> arg1, FunctorRef<?,?> arg2)
            throws ParseException
    {
        BinaryFunctorRef<?,?,R> ref =
            new BinaryFunctorRef(bf, arg1.getReturnType(), arg2.getReturnType(), fType);

        return bindBinaryFn(ref, arg1, arg2);
    }


    /**
     */
    private FunctorRef bindBinaryFn(BinaryFunctorRef bf, FunctorRef arg1, FunctorRef arg2)
            throws ParseException
    {
        // First, check the arguments to ensure that the two arg functors produce what the
        // binary functor needs, boxing/unboxing either or both as necessary
        FunctorRef fn1 = boxUnboxFunctor(bf.getArgType(0), arg1);
        FunctorRef fn2 = boxUnboxFunctor(bf.getArgType(1), arg2);
        if (fn1 == null || fn2 == null) {
            String err = "{0} requires arguments of {1} and {2}: received {3} and {4}";
            String msg =
                MessageFormat.format(err, new Object[]{ bf.getFunctor(),bf.getArgType(0),
                                                        bf.getArgType(1),arg1.getReturnType(),
                                                        arg2.getReturnType()} );
            throw new ParseException (msg);
        }

        arg1 = fn1; arg2 = fn2;

        // Next, build a FunctorRef appropriate for the combination of the given
        // binary functor with its arguments.
        if (arg1.isConstant()) {
            Object val1 = ((GeneratorRef) arg1).getFunctor().fn();

            if (arg2.isConstant()) {
                Object val2 = ((GeneratorRef) arg2).getFunctor().fn();

                if (isStable(bf.getFunctor()))
                    return new GeneratorRef(new Constant(bf.getFunctor().fn(val1,val2)),
                                            bf.getReturnType());
                else
                    return new GeneratorRef(bf.getFunctor().bind(val1,val2), bf.getReturnType());
            }
            else if (arg2.getNumberArgs() == 0) {
                Generator gen2 = ((GeneratorRef) arg2).getFunctor();
                return new GeneratorRef(bf.getFunctor().bind1st(val1).generate(gen2),
                                        bf.getReturnType());
            }
        }
        else if (arg1.getNumberArgs() == 0) {
            Generator gen1 = ((GeneratorRef) arg1).getFunctor();
            if (arg2.isConstant()) {
                Object val2 =((GeneratorRef) arg2).getFunctor().fn();
                return new GeneratorRef(bf.getFunctor().generate1st(gen1).bind(val2),
                                        bf.getReturnType());
            }
            else if (arg2.getNumberArgs() == 0) {
                Generator gen2 = ((GeneratorRef) arg2).getFunctor();
                return new GeneratorRef(bf.getFunctor().generate(gen1, gen2), bf.getReturnType());
            }
        }

        throw new ParseException("Cannot bind ["+bf+"] with args ["+arg1+"] and ["+arg2+"]");
    }


    /**
     */
    private FunctorRef bindConditional (FunctorRef condExp, FunctorRef trueExp, FunctorRef falseExp)
        throws ParseException
    {
        // TODO: if either is a boxed form of the other, is it OK???
        if (!trueExp.getReturnType().equals(falseExp.getReturnType())) {
            String err = "Conditional Expression may not be applied to results of {0} and {1}";
            String msg = MessageFormat.format(err, new Object[]{ trueExp.getReturnType(),
                                                                 falseExp.getReturnType()} );
            throw new ParseException(msg);
        }

        Generator condFn  = ((GeneratorRef) condExp).getFunctor();
        Generator trueFn  = ((GeneratorRef) trueExp).getFunctor();
        Generator falseFn = ((GeneratorRef) falseExp).getFunctor();
        ConditionalGenerator fn = new ConditionalGenerator(condFn, trueFn, falseFn);
        return new GeneratorRef(fn, trueExp.getReturnType());
    }


    /**
     */
    private FunctorRef bindConditionalLogic (String op, FunctorRef leftExp, FunctorRef rightExp)
        throws ParseException
    {
        assert(op.equals("&&") || op.equals("||"));
        Class<?> leftType = leftExp.getReturnType();
        Class<?> rightType = rightExp.getReturnType();
        if ( ! (leftType.equals(Boolean.class) && rightType.equals(Boolean.class))) {
            String err = "{0} requires Boolean arguments: received {1} and {2}";
            String msg = MessageFormat.format(err, new Object[]{ op,leftType,rightType} );
            throw new ParseException(msg);
        }

        Generator leftFn  = ((GeneratorRef) leftExp).getFunctor();
        Generator rightFn = ((GeneratorRef) rightExp).getFunctor();
        Generator fn =
                op.equals("&&") ? new AndGenerator(leftFn,rightFn) : new OrGenerator(leftFn,rightFn);
        return new GeneratorRef(fn, Boolean.class);
    }


    /**
     */
    private FunctorRef bindCompoundFunctors(FunctorRef firstExp, FunctorRef secondExp)
        throws ParseException
    {
        Generator fn = new CompoundGenerator(((GeneratorRef) firstExp).getFunctor(),
                                             ((GeneratorRef) secondExp).getFunctor());
        return new GeneratorRef(fn, secondExp.getReturnType());
    }



    /**
     */
    private Class<?> resolveReturnType(Class<?> type) {
        return type.equals(Void.TYPE) ? Object.class : type;
    }

    //======================
    // Utility Methods
    //======================


    /**
     */
    private BinaryFunctorRef ensureBinary(FunctorRef fn, Class arg1Type, Class arg2Type)
            throws ParseException
    {
        BinaryFunctor bf = ensureBinary(fn);
        return new BinaryFunctorRef(bf, arg1Type, arg2Type, fn.getReturnType());
    }

    /**
     */
    private BinaryFunctor ensureBinary(FunctorRef fn) throws ParseException {
        if (fn.isConstant())
            return new ConstantBinary(((GeneratorRef) fn).getFunctor().fn());

        switch (fn.getNumberArgs()) {
        case 0:
            return new GenerateBinary(((GeneratorRef) fn).getFunctor());
        case 1:
            return ((UnaryFunctorRef) fn).getFunctor().compose(new Project1st());
        case 2:
            return ((BinaryFunctorRef) fn).getFunctor();

        default:
            throw new ParseException("Cannot bind ["+fn+"] as BinaryFunctor");
        }
    }


    /**
     */
    private UnaryFunctorRef ensureUnary(FunctorRef fn, Class argType, String argName)
            throws ParseException
    {
        UnaryFunctor uf = ensureUnary(fn);
        return new UnaryFunctorRef(uf, argType, argName, fn.getReturnType());
    }

    /**
     */
    private UnaryFunctor ensureUnary(FunctorRef fn) throws ParseException {
        if (fn.isConstant())
            return new ConstantUnary(((GeneratorRef) fn).getFunctor().fn());

        switch (fn.getNumberArgs()) {
        case 0:
            return new GenerateUnary(((GeneratorRef) fn).getFunctor());
        case 1:
            return ((UnaryFunctorRef) fn).getFunctor();
        default:
            throw new ParseException("Cannot bind ["+fn+"] as UnaryFunctor");
        }
    }

    // TODO: support registration/unregistration of comparators
    // this will likely get more elaborate: we need to allow users to register comparators
    // to be used with specific classes, and we might also add a parseComparator method to
    // allow users to build comparators on the fly

    /**
     * 
     */
    private Comparator getComparator(Class<?> type) {
        if (Comparable.class.isAssignableFrom(type))
            return new ComparableComparator();

        String err = "No comparator registered for type {0}";
        throw new IllegalArgumentException(MessageFormat.format(err, new Object[]{type}));
    }

    /**
     * 
     */
    private Arithmetic getMath(Class type) throws ParseException {
        Arithmetic math = ArithmeticFactory.getArithmetic(type);
        if (math != null)
            return math;

        String msg = "No arithmetic implemented for {0}";
        throw new ParseException(MessageFormat.format(msg, new Object[]{type}));
    }


    /**
     * Builds object references by resolving the name to the right of a dot in
     * terms of the name built up so far on the left of the dot (and its current
     * interpretation.  Returns a functor that corresponds to the object, which
     * may be a class constant, an object reference, or a method call.  If the
     * name cannot be resolved meaningfully, then return null.  This method is
     * used primarily to parse the initial prefix of a dotted object reference,
     * although the grammar can be greedy about parsing past the shortest possible
     * prefix.  In this method, the prefix may be null.
     */
    private FunctorRef<?,?> resolveName(ParserContext context, StringBuffer buffer,
                                      FunctorRef<?,?> prefix, String name)
            throws ParseException
    {
        // First, see if we have a class name.
        buffer.append(name);
        Class<?> c = findClass(context, buffer.toString());
        if (c != null) {
            return new GeneratorRef(new Constant(c), Class.class);
        }

        // If we don't have a prefix yet, then we can only resolve a class
        // reference at this point, and apparently (since we failed to load
        // a class a few lines ago) we can't do that yet.
        if (prefix == null)
            return null;

        // Since we do have a prefix, we can defer to the rest of the method 
        return resolveName(prefix, name);
    }


    /**
     * Builds object references by resolving the name to the right of a dot in
     * terms of the name built up so far on the left of the dot (and its current
     * interpretation.  This method is used primarily after the initial prefix
     * has been recognized, and the prefix arg may not be null
     */
    private FunctorRef<?,?> resolveName(FunctorRef<?,?> prefix, String name) throws ParseException {
        // If prefix is a Class Constant, then member is assumed to be static and a null
        // argument will be bound to the returned functor

        if (isClassReference(prefix)) {
            Class<?> type = getReferencedClass(prefix);
            FunctorRef fn = EnumHandler.checkEnum(type, name);
            if (fn != null)
                return fn;

            // TODO: check for nested class here ???

            GetField getfld = new GetField(type, name);
            fn = new GeneratorRef(getfld.bind(null),getfld.getFieldType());
            return fn;
        }
        else {
            // If the prefix is not a Class Constant, the the prefix's type will be used to 
            // to reflect on the correct member field.  The argument will be the prefix's
            // result.
            Class<?> prefixType = prefix.getReturnType();
            GetField getfld = new GetField(prefixType, name);
            FunctorRef fn = bindUnaryFn(new UnaryFunctorRef(getfld,prefixType,"",
                                                            getfld.getFieldType()), prefix);
            return fn;
        }
    }

    /**
     * Returns a functor ref containing a functor that corresponds to a call to the named
     * method with the given args.  
     */
    protected FunctorRef<?,?> resolveMethodName(FunctorRef<?,?> prefix, String name, FunctorRef<?,?>[] args)
            throws ParseException
    {
        Class<?> type = isClassReference(prefix) ? getReferencedClass(prefix) : prefix.getReturnType();

        // Create an array of argument types, from the return types of the arguments
        Class<?>[] argtypes = makeTypeList(args);

        // See if the method is predefined.  
        BinaryFunctorRef im = reservedMethod(prefix, name, argtypes);

        // If not, then resolve the method via reflection
        FunctorRef argsRef = getArgExpressionList(args);

        if(im == null) {
            try {
                Method method = resolveMethod(type, name, argtypes);
                im = new BinaryFunctorRef(new InvokeMethod(type, method), type,
                                          argsRef.getReturnType(), method.getReturnType());
            }
            catch (NoSuchMethodException x) {
                String err = "No Method {0} found";
                String msg = MessageFormat.format(err, new Object[]{x.getMessage()});
                ParseException px = new ParseException(msg);
                px.initCause(x);
                throw px;
            }
        }

        Class<?> returnType = resolveReturnType(im.getReturnType());

        // Bind the object (null if the method is static) and its arguments 
        if(args.length == 0) {
            if (isClassReference(prefix)) {
                return new GeneratorRef(im.getFunctor().bind(null, new Object[0]), returnType);
            }
            else {
                UnaryFunctorRef ref =
                    new UnaryFunctorRef(im.getFunctor().bind2nd(new Object[0]), type, "", returnType);
                return bindUnaryFn(ref, prefix);
            }
        }
        else {
            if (isClassReference(prefix)) {
                UnaryFunctorRef ref =
                    new UnaryFunctorRef(im.getFunctor().bind1st(null), argsRef.getReturnType(), "", returnType);
                return bindUnaryFn(ref, argsRef);
            }
            else {
                return bindBinaryFn(im, prefix, argsRef);
            }
        }
    }


    /**
     * Returns a functor which returns a list of results from evaluating the given list
     * of arguments.
     */
    private FunctorRef<?,?> getArgExpressionList(FunctorRef<?,?>[] args) throws ParseException {
        Generator[] gens = new Generator[args.length];
        for (int i = 0; i < args.length; ++i) {
            gens[i] = ((GeneratorRef) args[i]).getFunctor();
        }

        ApplyGenerator listgen = new ApplyGenerator(gens);
        return new GeneratorRef(listgen, Object[].class);
    }


    /**
     * Returns a functor ref containing a functor that corresponds to a call to the named
     * static method (imported) with the given args, or null if no such method has been
     * imported.
     */
    private FunctorRef resolveImportedMethod(ParserContext context, String name, FunctorRef[] args)
            throws ParseException
    {
        // Create an array of argument types, from the return types of the argument expressions
        Class<?>[] argTypes = makeTypeList(args);
        Method method = findBestMethod(name, context.getImportedMethods(name), argTypes);
        if (method == null) {
            return null;
        }

        if (args.length == 0) {
            return new GeneratorRef(new InvokeNoArgMethod(method.getClass(), method).bind(null),
                                    resolveReturnType(method.getReturnType()));
        }
        else {
            // Wrap the arguments in an ApplyFoo functor, where foo is one of Generator|Unary|Binary
            // depending on which (if any) unknowns are present anywhere in the argument expressions.
            FunctorRef argsRef = getArgExpressionList(args);

            // TODO: Boxing/Unbox the arguments, as necessary

            // Build an InvokeMethod that will call the correct method
            InvokeMethod im = new InvokeMethod(method.getDeclaringClass(), method);
            UnaryFunctorRef ref = new UnaryFunctorRef(im.bind1st(null),argsRef.getReturnType(),"",
                                                      resolveReturnType(method.getReturnType()));
            return bindUnaryFn(ref, argsRef);
        }
    }


    /**
     * Returns the method that best matches the available argument types
     */
    private Method resolveMethod(Class<?> c, String name, Class<?>[] argTypes)
        throws NoSuchMethodException, ParseException
    {
        // If the naive thing fails, save the exception -- if none of the
        // fallbacks work, we'll throw the original exception
        NoSuchMethodException firstException = null;

        // First, try the obvious thing
        try {
            return c.getMethod(name, argTypes);
        }
        catch (NoSuchMethodException x) {
            if (argTypes.length == 0)
                    // NOTE: when written, this couldn't happen -- this method was originally
                    // only called when the argument length was 1.  This check is purely
                    // defensive, so I don't forget to put it in in case the calling changes.
                throw x;

            firstException = x;
        }

        // Since the obvious thing didn't work, we'll find the best matching method
        // available.
        Method bestMethod = findBestMethod(name, c.getMethods(), argTypes);
        if (bestMethod != null)
            return bestMethod;

        throw firstException;
    }

    /**
     * Selects the best fit method from the given set for the given set of argument
     * types.
     */
    private Method findBestMethod(String name, Method[] methods, Class<?>[] argTypes) {
        int bestScore = Integer.MAX_VALUE;
        Method bestMethod = null;

        for (int i = 0; i < methods.length; ++i) {
            if (methods[i].getName().equals(name)) {
                Class<?>[] parmTypes = methods[i].getParameterTypes();
                int score = scoreCompatability(parmTypes, argTypes);
                if (score < 0)
                    continue;

                if (score < bestScore) {
                    score = bestScore;
                    bestMethod = methods[i];
                }
            }
        }

        return bestMethod;
    }


    /**
     * Compares a list of parm types for a method/constructor with a list
     * of argument types, and computes a score.  -1 indicates that the two
     * lists are not compatable, while 0 indicates an exact match.
     * Otherwise, lower numbers are more exact matches than higher numbers.
     */
    private int scoreCompatability(Class<?>[] parmTypes, Class<?>[] argTypes) {
//         System.out.println("scoreCompatability("+Arrays.toString(parmTypes)+", "
//                                                 +Arrays.toString(argTypes)+")");
        if (parmTypes.length != argTypes.length)
            // TODO: account for variable argument lists -- if the last entry in ParmTypes
            // is an array, and if every object from corresponding position to the end of
            // the args array can be assigned to the parm types array, then the two lists
            // are compatable

            return -1;

        int score = 0;
        for (int i = 0; i < parmTypes.length; ++i) {
            if (parmTypes[i] == argTypes[i])
                continue;

            if (ParserUtils.isBoxedType(parmTypes[i], argTypes[i]) ||
                ParserUtils.isBoxedType(argTypes[i], parmTypes[i])) {
                score += 1;
                continue;
            }

            if (parmTypes[i].isAssignableFrom(argTypes[i])) {
                score += parmTypes.length;
                continue;
            }

            return -1;
        }

        return score;
    }


    /**
     *
     */
    private FunctorRef resolveConstructor(FunctorRef prefix, FunctorRef[] args)
            throws ParseException
    {

        if (!isClassReference(prefix)){
            String msg = "{0} is not a class reference";
            throw new ParseException(MessageFormat.format(msg, new Object[]{prefix}));
        }

        Class<?> type = getReferencedClass(prefix);
        if (args.length == 0) {
            try {
                ConstructDefault ctor0 = new ConstructDefault(type);
                GeneratorRef gen =  new GeneratorRef(ctor0, type);
                return gen;
            }
            catch(IllegalArgumentException x) {
                ParseException px = new ParseException(x.getMessage());
                px.initCause(x);
                throw px;
            }
        }

        // Create an array of argument types, from the return types of the argument expressions
        Class<?>[] argTypes = makeTypeList(args);

        // If the naive thing fails, save the exception -- if none of the
        // fallbacks work, we'll throw the original exception
        NoSuchMethodException firstException = null;

        // The constructor with which to build a functor
        Constructor ctor = null;

        // First, try the obvious thing
        try {
            ctor = type.getConstructor(argTypes);
        }
        catch (NoSuchMethodException x) {
            firstException = x;
        }

        if (ctor == null) {
            // Since the obvious thing didn't work, we'll find the best matching constructor
            // available.
            Constructor[] constructors = type.getConstructors();
            int bestScore = Integer.MAX_VALUE;

            for (int i = 0; i < constructors.length; ++i) {
                Class<?>[] parmTypes = constructors[i].getParameterTypes();
                int score = scoreCompatability(parmTypes, argTypes);
                if (score < 0)
                    continue;

                if (score < bestScore) {
                    score = bestScore;
                    ctor = constructors[i];
                }
            }
        }

        // If we've identified a constructor in either of the previous steps,
        if (ctor != null) {
            Construct ctorfn = new Construct(ctor);

            // Wrap the arguments in an ApplyFoo functor, where foo is one of Generator|Unary|Binary
            // depending on which (if any) unknowns are present anywhere in the argument expressions.
            FunctorRef argsRef = getArgExpressionList(args);

            // TODO: Boxing/Unbox the arguments, as necessary

            UnaryFunctorRef ref = new UnaryFunctorRef(ctorfn, argsRef.getReturnType(), "", type);
            return bindUnaryFn(ref, argsRef);
        }

        // We couldn't identify a constructor: punt
        String err = "No matching constructor found";
        ParseException px = new ParseException(err);
        px.initCause(firstException);
        throw px;
    }


    /**
     * returns true if the functor reference is one that returns a specific class object.
     */
    protected boolean isClassReference(FunctorRef ref) {
        return ref.isConstant() && ref.getReturnType().equals(Class.class);
    }


    /**
     * returns the specific class to which the given class refers.  Assumes isClassReference(ref),
     * will throw ClassCastException if not
     */
    protected Class<?> getReferencedClass(FunctorRef ref) {
        return (Class)((GeneratorRef) ref).getFunctor().fn();
    }


    /**
     */
    private Class<?> findClass(ParserContext context, String name) {
        // First we check if the name is in the java.lang resources.  We've kept
        // this bundle private, and this heads off attempts to hide java.lang
        // classes.  
        Class<?> c = (Class) javalang.get(name);
        if (c != null)
            return c;

        // Since it isn't a java.lang class, we check our 'imports' to see if
        // we've been told about it.
        Object val = context.getImportedClass(name);
        if (val instanceof Class)
            return (Class) val;

        if (val != null)
            name = val.toString();

        // We don't have an import: try to load the class directly and hope for
        // the best.
        try {
            return Class.forName(name);
        }
        catch (ClassNotFoundException x) {
            return null;
        }
    }


    /**
     *
     */
    private Character decodeChar(StringBuffer str) throws ParseException {
        char c0 = str.charAt(0), c1, c2, c3 ,c4, c5;
        if (c0 != '\u005c\u005c') {
            str.deleteCharAt(0);
            return new Character(c0);
        }

        c1 = str.charAt(1);
        switch (c1) {
        case '\u005c\u005c': str.delete(0,2); return new Character('\u005c\u005c');
        case 'n':  str.delete(0,2); return new Character('\u005cn');
        case 't':  str.delete(0,2); return new Character('\u005ct');
        case 'b':  str.delete(0,2); return new Character('\u005cb');
        case 'r':  str.delete(0,2); return new Character('\u005cr');
        case 'f':  str.delete(0,2); return new Character('\u005cf');
        case '\u005c'': str.delete(0,2); return new Character('\u005c'');
        case '"':  str.delete(0,2); return new Character('"');

// Note: Unicode escapes are headed off by the UnicodeCharStream that is
// used to read the data into the parser: this sequence shouldn't happen
        case 'u':
            throw new ParseException("Unicode should have been interpreted by the input stream");

        case '0':
        case '1':
        case '2':
        case '3':
            if (str.length() >= 4) {
                c2 = str.charAt(2);
                c3 = str.charAt(3);
                if (c2 >= '0' && c2 <= '7' && c3 >= '0' && c3 <= '7') {
                    char c = (char) (Integer.decode("0"+str.substring(1,4)).intValue());
                    str.delete(0,4);
                    return new Character(c);
                }
            }

        case '4':
        case '5':
        case '6':
        case '7':
            if (str.length() < 3) {
                str.delete(0,2);
                return new Character((char) (Character.digit(c1,8)));
            }

            c2 = str.charAt(2);
            if (c2 >= '0' && c2 <= '7') {
                char c = (char) (Integer.decode("0"+str.substring(1,3)).intValue());
                str.delete(0,3);
                return new Character(c);
            }
            else {
                str.delete(0,2);
                return new Character((char) (Character.digit(c1,8)));
            }
        }

        throw new ParseException("Unknown leading character \u005c""+str+"\u005c"");
    }


    /**
     * Returns an array containing the types of the arguments in the input array
     */
    private Class<?>[] makeTypeList(FunctorRef[] args) {
        Class<?>[] types = new Class[args.length];
        for (int i = 0; i < types.length; ++i)
            types[i] = args[i].getReturnType();

        return types;
    }


    // Private functor wrapping up the StringBuffer.append(String) method.  append 
    // returns the StringBuffer on which it was called, making this functor a
    // BinaryFunctor<StringBuffer,String,StringBuffer>
    private InvokeMethod invokeAppendString =
        new InvokeMethod(StringBuffer.class, "append", String.class);


    /**
     * Returns a reference to a functor that begins a string concatenation expression by
     * building a StringBuffer with an argument of the class ltype to which an argument
     * of type rtype will be appended.
     */
    private BinaryFunctor startStringConcat(Class<?> type) {
        return invokeAppendString.distribute(buildStringBuffer(type), new ArrayUnary());
    }


    /**
     * Functor that builds the StringBuffer: if the type we'll be given is not a String,
     * then we need to call its argument's toString() method
     */
    private UnaryFunctor buildStringBuffer(Class<?> type) {
        // Functor wrapping the StringBuffer(String) ctor
        UnaryFunctor ctor = new ConstructUnary(String.class, StringBuffer.class);

        // If the argument type isn't String, chain the previous ctor to a toString() call 
        if ( ! (type.equals(String.class))) {
            ctor = ctor.compose(new DefaultFormat());
        }

        return ctor;
    }


    /**
     * Returns a reference to a functor that begins a string concatenation expression by
     * building a StringBuffer with an argument of the class ltype to which an argument
     * of type rtype will be appended.
     */
    private BinaryFunctor continueStringConcat() {
        return invokeAppendString.distribute(new Identity(), new ArrayUnary());
    }

    /**
     * Deconstructs a functor representing the LHS of an assignment statement in order
     * to replace the getter recognized by the Name/PrimaryExpression production with
     * a setter.  After calling visit(Functor), the assignmentFn property will contain
     * the functor that assigns the field/variable to the results of the rhs functor
     */

    class AssignmentVisitor<T> extends AbstractVisitor
            implements Bind.Visitor, Generate.Visitor, GetField.Visitor, Identity.AccessorVisitor
    {
        private GeneratorRef<T> lhs;
        private GeneratorRef<T> rhs;
        private AssignmentOperator op;
        private ParserContext context;

        private FunctorRef<T,? extends Functor<T>> assignmentFn;

        public AssignmentVisitor(ParserContext context, GeneratorRef<T> lhs, GeneratorRef<T> rhs,
                                 AssignmentOperator op)
        {
                this.context = context;
                this.lhs = lhs;
            this.rhs = rhs;
            this.op = op;
        }

        public FunctorRef<T,? extends Functor<T>> getAssignmentExpression() { return assignmentFn; }

        private Generator<?> gen;

        // getField | getField.generate

        // a GetField.bind() is a field of a constant value, typically a class constant
        public void visit(Bind<?,?> host) {
            host.getFunctor().accept(this);
        }

        // a Generate represents the result of some expression
        public void visit(Generate<?,?> host) {
            gen = host.getGenerator();
            host.getFunctor().accept(this);
        }

        // an Identity.Accessor is a reference to a local variable or argument
        @SuppressWarnings("unchecked") // the parser ensures (or will, at least) that the types are OK
        public void visit(Identity.Accessor<?> host) {
            Identity.Accessor<T> id = (Identity.Accessor<T>) host;
            GeneratorRef<T> boundRhs = bindAssignment(lhs, op, rhs);
            assignmentFn =
                new GeneratorRef<T>(id.getIdentity().generate(boundRhs.getFunctor()), boundRhs.getReturnType());
        }

        // a GetField is a field reference of some type: might be static, final, private, etc.
        public void visit(GetField<?,?> host) {
            try {
                Field field = host.getField();
                int mods = field.getModifiers();
                if (Modifier.isFinal(mods)) {
                    String msg = "cannot assign to final field {0}";
                    throw new UncheckedParseException(MessageFormat.format(msg, field));
                }

                if (Modifier.isPrivate(mods)) {
                    String msg = "cannot assign to private field {0}";
                    throw new UncheckedParseException(MessageFormat.format(msg, field));
                }

                SetAndReturnField setter = new SetAndReturnField(field);
                GeneratorRef<T> boundRhs = bindAssignment(lhs, op, rhs);
                Generator assignment = boundRhs.getFunctor();

                if (gen != null) // we're in a GetField.generate(), getting a field of a runtime object
                    assignment = setter.generate(gen, assignment);
                else             // we're in a GetField.bind(), getting a field of a constant object
                    assignment = setter.bind1st(null).generate(assignment);

                assignmentFn = new GeneratorRef<T>(assignment, boundRhs.getReturnType());
            }
            catch (NoSuchFieldException x) {
                ParseException px = new ParseException(x.getMessage());
                px.initCause(x);
                throw new UncheckedParseException(px);
            }
        }


        private GeneratorRef<T>
        bindAssignment(GeneratorRef<T> lhs, AssignmentOperator operator, GeneratorRef<T> rhs) {
            try {
                Class<T> ltype = lhs.getReturnType();
                GeneratorRef<T> gref = (GeneratorRef) makeValueFn(ltype, lhs, operator, rhs);

                FunctorRef promotion = promote(gref, ltype);
                if (promotion != null)
                    return (GeneratorRef) promotion;

                Class<?> valueType = gref.getReturnType();
                UnaryFunctor demoter = context.getDemotionRule(valueType, ltype);
                if (demoter != null)
                    return new GeneratorRef(demoter.generate(gref.getFunctor()), ltype);

                String msg = "Cannot convert from {0} to {1}";
                throw new ParseException(MessageFormat.format(msg, valueType, ltype));
            }
            catch (ParseException x) {
                throw new UncheckedParseException(x);
            }
        }

        private FunctorRef makeValueFn(Class ltype, GeneratorRef lhs, AssignmentOperator operator, GeneratorRef rhs) throws ParseException {
        // TODO: Handle string concatenation via += operator
            if (ltype == String.class) {
                BinaryFunctor bf = new DefaultFormat().compose(startStringConcat(String.class));
                return bindBinaryFn(new BinaryFunctorRef(bf, String.class, Object.class, String.class), lhs, rhs);
            }

        // TODO: finish out this switch for the rest of the op= set
            switch(operator) {
            case ASSIGN:   return rhs;
            case PLUS_EQ:  return bindBinaryOperation(Number.class, ArithmeticOperator.PLUS, lhs, rhs);
            case MINUS_EQ: return bindBinaryOperation(Number.class, ArithmeticOperator.MINUS, lhs, rhs);
            case TIMES_EQ: return bindBinaryOperation(Number.class, ArithmeticOperator.TIMES, lhs, rhs);
            case DIVIDE_EQ:return bindBinaryOperation(Number.class, ArithmeticOperator.DIVIDES, lhs, rhs);
            case MOD_EQ:   return bindBinaryOperation(Number.class, ArithmeticOperator.MODULUS, lhs, rhs);
            case SHL_EQ:
                checkShiftTypes(ltype, rhs);
                return bindBinaryFn(new ShiftLeft(ltype), ltype, lhs, rhs);

            case SHR_EQ:
                checkShiftTypes(ltype, rhs);
                return bindBinaryFn(new ShiftRight(ltype), ltype, lhs, rhs);

            case UNSHR_EQ:
                checkShiftTypes(ltype, rhs);
                return bindBinaryFn(new UnsignedShiftRight(ltype), ltype, lhs, rhs);

            case AND_EQ:
                if (ltype.equals(Boolean.class))
                    return bindBinaryFn(new LogicalAnd(), Boolean.class, lhs, rhs);
                else
                    return bindBinaryFn(new BitwiseAnd(ltype), ltype, lhs, rhs);

            case OR_EQ:
                if (ltype.equals(Boolean.class))
                    return bindBinaryFn(new LogicalOr(), Boolean.class, lhs, rhs);
                else
                    return bindBinaryFn(new BitwiseOr(ltype), ltype, lhs, rhs);

            case XOR_EQ:
                if (ltype.equals(Boolean.class))
                    return bindBinaryFn(new NotEqualTo(), Boolean.class, lhs, rhs);
                else
                    return bindBinaryFn(new BitwiseXor(ltype), ltype, lhs, rhs);

            default:
                String msg = "Unknown Operator Type {0} (who wrote this mess??)";
                throw new UncheckedParseException(MessageFormat.format(msg, operator));
            }
        }

        private void checkShiftTypes(Class<?> ltype, GeneratorRef rhs) throws ParseException {
                Class<?> rtype = rhs.getReturnType();
            if (! isIntegralType(ltype) || rtype != Integer.class) {
                String err = "Shift expression requires arguments of an integral type and an integer: "
                           + "received {0} and {1}";
                throw new ParseException(MessageFormat.format(err, ltype, rtype));
            }
        }
    }

  final public FunctorRef Functor(ParserContext context) throws ParseException {
    FunctorRef fn;
    fn = CompoundExpression(context);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 26:
      jj_consume_token(26);
      break;
    default:
      ;
    }
    jj_consume_token(0);
        VariableRef<?>[] args = context.describeArgumentSpace();
        UnaryFunctor<?,?>[] ids = context.getArgumentSpace();
        if (args.length == 0)
           {if (true) return fn;}

        Multiplex mx = new Multiplex(context.getArgumentSpace());
        if (args.length == 1) {
                UnaryFunctor<?,?> uf = new CompoundUnary(ids[0], ensureUnary(fn));
                {if (true) return new UnaryFunctorRef(uf, args[0].getType(), args[0].getName(), fn.getReturnType());}
        }
        else if (args.length == 2) {
                Distribute<?,?,?,?,?> d = new Distribute(ids[0], ids[1], new ConstantBinary<Object,Object,Object>(null));
                BinaryFunctor<?,?,?> bf = new CompoundBinary(d, ensureBinary(fn));
                {if (true) return new BinaryFunctorRef(bf, args[0].getType(), args[1].getType(), fn.getReturnType());}
        }
        else {
            Functor<?> fn2 = new Compound(mx, fn.getFunctor());
            {if (true) return new VariableFunctorRef(fn2, fn.getReturnType(), args);}
        }
    throw new Error("Missing return statement in function");
  }

/*
FunctorRef Block(ParserContext context) :
{
	FunctorRef fn;
}
{
	(   
	    LOOKAHEAD(3) "{" <INTEGER_LITERAL> "}"|":" 
		fn = CompoundExpression(context)
	|
	    LOOKAHEAD(3)    
        "{" fn = CompoundExpression(context) "}" 
    |
         fn = CompoundExpression(context)
    )
    { return fn; }
}
*/
  final public FunctorRef CompoundExpression(ParserContext context) throws ParseException {
    FunctorRef fn = new GeneratorRef(new Constant(null), Void.TYPE);
    FunctorRef fn2;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FALSE:
    case NEW:
    case NULL:
    case THIS:
    case TRUE:
    case LPAREN:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case 56:
    case 57:
    case 61:
    case 62:
    case 64:
      fn = Expression(context);
      break;
    default:
      ;
    }
    label_1:
    while (true) {
      if (jj_2_1(2)) {
        ;
      } else {
        break label_1;
      }
      jj_consume_token(26);
      fn2 = Expression(context);
          fn = bindCompoundFunctors(fn, fn2);
    }
      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Expression(ParserContext context) throws ParseException {
    FunctorRef fn, getter;
    if (jj_2_2(2147483647)) {
      fn = LocalVariableDeclaration(context);
    } else if (jj_2_3(2147483647)) {
      fn = AssignmentExpression(context);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FALSE:
      case NEW:
      case NULL:
      case THIS:
      case TRUE:
      case LPAREN:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case 56:
      case 57:
      case 61:
      case 62:
      case 64:
        fn = ConditionalExpression(context);
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef LocalVariableDeclaration(ParserContext context) throws ParseException {
        FunctorRef fn, fn2, classref;
        Class<?> type;
    classref = Type(context);
            if (!isClassReference(classref)) {
                String msg = "Unknown type {0}";
                {if (true) throw new ParseException(MessageFormat.format(msg, classref));}
            }

            type = getReferencedClass(classref);
    fn = VariableDeclarator(context, type);
    label_2:
    while (true) {
      if (jj_2_4(2)) {
        ;
      } else {
        break label_2;
      }
      jj_consume_token(27);
      fn2 = VariableDeclarator(context, type);
                  fn = fn2;
    }
          {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef VariableDeclarator(ParserContext context, Class<?> type) throws ParseException {
        VariableRef<?> ref;
    FunctorRef fn = new GeneratorRef(new Constant(null), Void.TYPE);
    ref = VariableDeclaratorId(context, type);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 28:
      jj_consume_token(28);
      fn = VariableInitializer(context, type);
            UnaryFunctorRef<?,?> assignment = new UnaryFunctorRef(ref.mutator(), type, "", type);
            // TODO: if we're in an assignment statement and the rhs is the first appearance of 
            // a positional argument, then use the assignment type to infer the type of the
            // argument
                fn = bindUnaryFn(assignment, fn);
      break;
    default:
      ;
    }
      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public VariableRef<?> VariableDeclaratorId(ParserContext context, Class<?> type) throws ParseException {
    VariableRef<?> ref;
    Token t;
    t = jj_consume_token(IDENTIFIER);
        ref = context.resolveName(t.image);
        if (ref != null) {
                String msg = "variable name \u005c"{0}\u005c" already defined";
                {if (true) throw new ParseException(MessageFormat.format(msg, t.image));}
        }

        ref = context.declareVariable(t.image, type);
      {if (true) return ref;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef VariableInitializer(ParserContext context, Class<?> type) throws ParseException {
    FunctorRef fn = null;
      context.setInferredType(type);
    fn = ConditionalExpression(context);
      context.setInferredType(null); {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

/*
void ArrayInitializer():
{}
{
  "{" [ VariableInitializer() ( LOOKAHEAD(2) "," VariableInitializer() )* ] [ "," ] "}"
}
*/
  final public FunctorRef AssignmentExpression(ParserContext context) throws ParseException {
        FunctorRef lhs, rhs;
        AssignmentOperator op;
    lhs = PrimaryExpression(context);
    op = AssignmentOperator();
    rhs = ConditionalExpression(context);
        if (lhs.isConstant()) {
                String msg = "cannot assign to constant value {0}";
                {if (true) throw new ParseException(MessageFormat.format(msg, lhs.getFunctor().eval()));}
        }

        Functor fn = lhs.getFunctor();
        AssignmentVisitor vis = new AssignmentVisitor(context, (GeneratorRef) lhs, (GeneratorRef) rhs, op);
        fn.accept(vis);
        lhs = vis.getAssignmentExpression();
    {if (true) return lhs;}
    throw new Error("Missing return statement in function");
  }

  final public AssignmentOperator AssignmentOperator() throws ParseException {
    AssignmentOperator op;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 28:
      jj_consume_token(28);
                op = AssignmentOperator.ASSIGN;
      break;
    case 29:
      jj_consume_token(29);
                op = AssignmentOperator.PLUS_EQ;
      break;
    case 30:
      jj_consume_token(30);
                op = AssignmentOperator.MINUS_EQ;
      break;
    case 31:
      jj_consume_token(31);
                op = AssignmentOperator.TIMES_EQ;
      break;
    case 32:
      jj_consume_token(32);
                op = AssignmentOperator.DIVIDE_EQ;
      break;
    case 33:
      jj_consume_token(33);
                op = AssignmentOperator.MOD_EQ;
      break;
    case 34:
      jj_consume_token(34);
                op = AssignmentOperator.SHL_EQ;
      break;
    case 35:
      jj_consume_token(35);
                op = AssignmentOperator.SHR_EQ;
      break;
    case 36:
      jj_consume_token(36);
                op = AssignmentOperator.UNSHR_EQ;
      break;
    case 37:
      jj_consume_token(37);
                op = AssignmentOperator.AND_EQ;
      break;
    case 38:
      jj_consume_token(38);
                op = AssignmentOperator.XOR_EQ;
      break;
    case 39:
      jj_consume_token(39);
                op = AssignmentOperator.OR_EQ;
      break;
    default:
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return op;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef ConditionalExpression(ParserContext context) throws ParseException {
    FunctorRef condExp, trueExp = null, falseExp = null;
    Class<?> lopType;
    condExp = ConditionalOrExpression(context);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 40:
      jj_consume_token(40);
      trueExp = Expression(context);
      jj_consume_token(41);
      falseExp = Expression(context);
      break;
    default:
      ;
    }
      if (trueExp == null || falseExp == null)
          {if (true) return condExp;}
      else
          {if (true) return bindConditional(condExp, trueExp, falseExp);}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef ConditionalOrExpression(ParserContext context) throws ParseException {
    BinaryFunctorRef bf;
    FunctorRef lop, rop;
    Class<?> lopType;
    lop = ConditionalAndExpression(context);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 42:
        ;
        break;
      default:
        break label_3;
      }
             lopType = lop.getReturnType();
      jj_consume_token(42);
             bf = new BinaryFunctorRef(new LogicalOr(), Boolean.class,Boolean.class,Boolean.class);
      rop = ConditionalAndExpression(context);
             lop = bindConditionalLogic("||", lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef ConditionalAndExpression(ParserContext context) throws ParseException {
    BinaryFunctorRef bf;
    FunctorRef lop, rop;
    Class<?> lopType;
    lop = OrExpression(context);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 43:
        ;
        break;
      default:
        break label_4;
      }
             lopType = lop.getReturnType();
      jj_consume_token(43);
             bf = new BinaryFunctorRef(new LogicalAnd(), Boolean.class,Boolean.class,Boolean.class);
      rop = OrExpression(context);
             lop = bindConditionalLogic("&&", lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef OrExpression(ParserContext context) throws ParseException {
    BinaryFunctorRef bf;
    FunctorRef lop, rop;
    Class<?> lopType;
    lop = XorExpression(context);
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 44:
        ;
        break;
      default:
        break label_5;
      }
            lopType = lop.getReturnType();
      jj_consume_token(44);
            if (lopType.equals(Boolean.class))
                bf = new BinaryFunctorRef(new LogicalOr(), lopType, lopType, lopType);
            else
                bf = new BinaryFunctorRef(new BitwiseOr(lopType), lopType, lopType, lopType);
      rop = XorExpression(context);
            lop = bindBinaryFn(bf, lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef XorExpression(ParserContext context) throws ParseException {
    BinaryFunctorRef bf;
    FunctorRef lop, rop;
    Class<?> lopType;
    lop = AndExpression(context);
    label_6:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 45:
        ;
        break;
      default:
        break label_6;
      }
           lopType = lop.getReturnType();
      jj_consume_token(45);
           if (lopType.equals(Boolean.class))
               bf = new BinaryFunctorRef(new NotEqualTo(), lopType, lopType, lopType);
           else
               bf = new BinaryFunctorRef(new BitwiseXor(lopType), lopType, lopType, lopType);
      rop = AndExpression(context);
           lop = bindBinaryFn(bf, lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef AndExpression(ParserContext context) throws ParseException {
    BinaryFunctorRef bf;
    FunctorRef lop, rop;
    Class<?> lopType;
    lop = EqualityExpression(context);
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 46:
        ;
        break;
      default:
        break label_7;
      }
             lopType = lop.getReturnType();
      jj_consume_token(46);
               if (lopType.equals(Boolean.class))
                   bf = new BinaryFunctorRef(new LogicalAnd(), lopType, lopType, lopType);
               else
                   bf = new BinaryFunctorRef(new BitwiseAnd(lopType), lopType, lopType, lopType);
      rop = EqualityExpression(context);
           lop = bindBinaryFn(bf, lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef EqualityExpression(ParserContext context) throws ParseException {
    FunctorRef lop, rop;
    ArithmeticOperator operator;
    lop = InstanceOfExpression(context);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 47:
      case 48:
        ;
        break;
      default:
        break label_8;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 47:
        jj_consume_token(47);
             operator = ArithmeticOperator.EQUAL;
        break;
      case 48:
        jj_consume_token(48);
             operator = ArithmeticOperator.NOTEQUAL;
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
      rop = InstanceOfExpression(context);
           lop = bindBinaryOperation(Object.class, operator, lop, rop);
    }
         {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef InstanceOfExpression(ParserContext context) throws ParseException {
    FunctorRef fn, classref;
    fn = RelationalExpression(context);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INSTANCEOF:
      jj_consume_token(INSTANCEOF);
      classref = Type(context);
          if (isClassReference(classref)) {
              Class<?> type = (Class)((GeneratorRef) classref).getFunctor().fn();
              UnaryFunctor inst = new InstanceOf(type);
              fn = bindUnaryFn(new UnaryFunctorRef(inst, fn.getReturnType(),"?",Boolean.class), fn);
          }
          else {
              String msg = "instanceof may only be applied to constant class reference";
              {if (true) throw new ParseException(msg);}
          }
      break;
    default:
      ;
    }
        {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef RelationalExpression(ParserContext context) throws ParseException {
    FunctorRef lop, rop;
    ArithmeticOperator operator;
    lop = ShiftExpression(context);
    label_9:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 49:
      case 50:
      case 51:
      case 52:
        ;
        break;
      default:
        break label_9;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 49:
        jj_consume_token(49);
            operator = ArithmeticOperator.LESS;
        break;
      case 50:
        jj_consume_token(50);
            operator = ArithmeticOperator.GREATER;
        break;
      case 51:
        jj_consume_token(51);
            operator = ArithmeticOperator.LESSEQUAL;
        break;
      case 52:
        jj_consume_token(52);
            operator = ArithmeticOperator.GREATEREQUAL;
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
      rop = ShiftExpression(context);
          lop = bindBinaryOperation(Comparable.class, operator, lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef ShiftExpression(ParserContext context) throws ParseException {
    BinaryFunctorRef bf;
    FunctorRef lop, rop;
    Class<?> lopType;
    lop = AdditiveExpression(context);
    label_10:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 53:
      case 54:
      case 55:
        ;
        break;
      default:
        break label_10;
      }
                lopType = ParserUtils.getBoxedType(lop.getReturnType());
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 53:
        jj_consume_token(53);
                bf = new BinaryFunctorRef(new ShiftLeft(lopType), lopType, Integer.class, lopType);
        break;
      case 54:
        jj_consume_token(54);
                bf = new BinaryFunctorRef(new ShiftRight(lopType),lopType, Integer.class, lopType);
        break;
      case 55:
        jj_consume_token(55);
                bf = new BinaryFunctorRef(new UnsignedShiftRight(lopType),
                                                                  lopType, Integer.class, lopType);
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
      rop = AdditiveExpression(context);
             if (! isIntegralType(lopType) || rop.getReturnType() != Integer.class) {
                 String err = "{0} requires arguments of an integral type and an integer: "
                            + "received {1} and {2}";
                 String msg = MessageFormat.format(err, new Object[]{ bf.getFunctor(),lopType,
                                                                      rop.getReturnType()} );
                 {if (true) throw new ParseException(msg);}
             }

             lop = bindBinaryFn(bf, lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

// TODO: work out character addition/subtraction

// TODO: combine string literals at parse time, only concat stringlits with expressions
  final public FunctorRef AdditiveExpression(ParserContext context) throws ParseException {
    BinaryFunctorRef bf;
    FunctorRef lop, rop;
    Class<?> lopType;
    ArithmeticOperator operator = null;
    lop = MultiplicativeExpression(context);
    label_11:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 56:
      case 57:
        ;
        break;
      default:
        break label_11;
      }
            lopType = lop.getReturnType();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 56:
        jj_consume_token(56);
              operator = ArithmeticOperator.MINUS;

              // If the left op is a character, we need to convert it to an integer.
              if (lopType.equals(Character.class)) {
                  lop = bindUnaryFn(charToInt, lop);
                  lopType = Integer.class;
              }

              bf = new BinaryFunctorRef(new Minus(ParserUtils.getBoxedType(lopType)),
                                        lopType, lopType, lopType);
        break;
      case 57:
        jj_consume_token(57);
              // If the left op is a String, then we're starting a string concatenation
              // expression, so we need to start a set of nested string buffer appends
              // with the creation of a string buffer
              if (lopType.equals(String.class)) {
                  bf = new BinaryFunctorRef(startStringConcat(String.class),
                                            String.class, String.class, StringBuffer.class);
              }

              // If the left op is a StringBuffer, then we're continuting a string
              // concatenation expression by adding an AppendString layer.  We're not
              // accounting for the type of the right side, yet (that'll come below).
              // Instead, we're assuming it to be a String
              else if (lopType.equals(StringBuffer.class)) {
                  bf = new BinaryFunctorRef(continueStringConcat(), lopType,
                                            Object.class, StringBuffer.class);
              }

              // Otherwise, this had better be numeric addition!
              else {

                  // If the left op is a character, we need to convert it to an integer.
                  if (lopType.equals(Character.class)) {
                      lop = bindUnaryFn(charToInt, lop);
                      lopType = Integer.class;
                  }

                  operator = ArithmeticOperator.PLUS;
                  bf = new BinaryFunctorRef(new Plus(ParserUtils.getBoxedType(lopType)),
                                            lopType,lopType,lopType);
              }
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
      rop = MultiplicativeExpression(context);
            // If both operands are string constants, then we replace them with a single
            // string constant that concatenates both at compile time.  The combining
            // functor remains a StringBuffer construction.
            if (isStringConst(lop) && isStringConst(rop)) {
                String lstr = (String)((Generator) lop.getFunctor()).fn();
                String rstr = (String)((Generator) rop.getFunctor()).fn();
                lop = new GeneratorRef(new Constant(lstr + rstr), String.class);
            }
            // If we're in a string concatenation expression and the right op is a String
            // then we simply append it by falling through here.  If the right op isn't a
            // String, we need to call toString() on its value
            else if (bf.getReturnType().equals(StringBuffer.class)) {
                if ( ! (rop.getReturnType().equals(String.class))) {
                    UnaryFunctorRef format =
                       new UnaryFunctorRef(new DefaultFormat(),rop.getReturnType(),"?",String.class);

                    rop = bindUnaryFn(format, rop);
                }

                lop = bindBinaryFn(bf, lop, rop);
            }

            // Otherwise, the pending operation must be an add.  If we get a string
            // here, we discard the addition and begin a string concatenation
            // can start a string concatenation by dropping the pending operation.  This
            // time, we have to format the left op 
            else if (rop.getReturnType().equals(String.class)) {
                UnaryFunctor ctor = buildStringBuffer(lop.getReturnType());
                UnaryFunctorRef ctorRef =
                    new UnaryFunctorRef(ctor, lop.getReturnType(), "?", StringBuffer.class);

                lop = bindUnaryFn(ctorRef, lop);
                bf = new BinaryFunctorRef(continueStringConcat(),
                                          StringBuffer.class, String.class, StringBuffer.class);

                lop = bindBinaryFn(bf, lop, rop);
            }
            // If we reach this point, then the pending operation is not a string concatenation
            // and neither argument is a string.

            else {
                  // If the right op is a character, we need to convert it to an integer.
                  if (rop.getReturnType().equals(Character.class)) {
                      rop = bindUnaryFn(charToInt, rop);
                  }

                lop = bindBinaryOperation(Number.class, operator, lop, rop);
            }
    }
          // One last thing: if we've just built a string concatenation expression,
          // then we want to get the string out of the resulting string buffer
          if (lop.getReturnType().equals(StringBuffer.class)) {
              UnaryFunctorRef format =
                  new UnaryFunctorRef(new DefaultFormat(), StringBuffer.class, "?", String.class);

              {if (true) return bindUnaryFn(format, lop);}
          }

          {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef MultiplicativeExpression(ParserContext context) throws ParseException {
    FunctorRef lop, rop;
    ArithmeticOperator operator = null;
    lop = UnaryExpression(context);
    label_12:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 58:
      case 59:
      case 60:
        ;
        break;
      default:
        break label_12;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 58:
        jj_consume_token(58);
            operator = ArithmeticOperator.TIMES;
        break;
      case 59:
        jj_consume_token(59);
            operator = ArithmeticOperator.DIVIDES;
        break;
      case 60:
        jj_consume_token(60);
            operator = ArithmeticOperator.MODULUS;
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
      rop = UnaryExpression(context);
          lop = bindBinaryOperation(Number.class, operator, lop, rop);
    }
        {if (true) return lop;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef UnaryExpression(ParserContext context) throws ParseException {
    FunctorRef operand;
    ArithmeticOperator operator = null;
    Class<?> type;
    Arithmetic math;
    UnaryFunctor uf;
    if (jj_2_5(2147483647)) {
      operand = CastExpression(context);
            {if (true) return operand;}
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FALSE:
      case NEW:
      case NULL:
      case THIS:
      case TRUE:
      case LPAREN:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case CHARACTER_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case 56:
      case 57:
      case 61:
      case 62:
      case 64:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 56:
        case 57:
        case 61:
        case 62:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case 57:
            jj_consume_token(57);
                operator = ArithmeticOperator.PLUS;
            break;
          case 56:
            jj_consume_token(56);
                operator = ArithmeticOperator.MINUS;
            break;
          case 61:
            jj_consume_token(61);
                operator = ArithmeticOperator.BITNOT;
            break;
          case 62:
            jj_consume_token(62);
                operator = ArithmeticOperator.LOGNOT;
            break;
          default:
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          ;
        }
        operand = PrimaryExpression(context);
          type = operand.getReturnType();
          if (type.isPrimitive()) {
              type = ParserUtils.getBoxedType(type);
              operand = boxUnboxFunctor(type, operand);
          }

          if (operator == null)
              {if (true) return operand;}

          switch(operator) {
          case PLUS:
              // getting the correct Arithmetic ensures that the operand has math
              // defined.  This check is somewhat pedantic (although it does ensure
              // that we don't allow stuff like '+"0"'
              math = getMath(type);
              {if (true) return operand;}

          case MINUS:
              // Ensuring the math is more important here, since the negate functor
              // does require an arithmetic implementation to operate properly
              math = getMath(type);
              uf = new Negate(type);
              {if (true) return bindUnaryFn(new UnaryFunctorRef(uf, type, "?", type), operand);}

          case BITNOT:
              // In this case, we'll let the bind args method kick out improper expression
              // argument types
              math = getMath(type);
              uf = new BitwiseNot(type);
              {if (true) return bindUnaryFn(new UnaryFunctorRef(uf, type,"?",type), operand);}

          case LOGNOT:
              // In this case, we'll let the bind args method kick out improper expression
              // argument types, since only Boolean is allowed.
              uf = new LogicalNot();
              {if (true) return bindUnaryFn(new UnaryFunctorRef(uf, Boolean.class,"?",Boolean.class), operand);}

          default:
              String msg = "Cannot use operator ''{0}'' in unary expression";
              {if (true) throw new ParseException(MessageFormat.format(msg, operator));}
          }

          {if (true) throw new ParseException("Unknown Operator: '"+operator+"'");}
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    throw new Error("Missing return statement in function");
  }

  final public void CastLookahead(ParserContext context) throws ParseException {
    jj_consume_token(LPAREN);
    Type(context);
    jj_consume_token(63);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 62:
      jj_consume_token(62);
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
      break;
    case IDENTIFIER:
      jj_consume_token(IDENTIFIER);
      break;
    case THIS:
      jj_consume_token(THIS);
      break;
    case NEW:
      jj_consume_token(NEW);
      break;
    case FALSE:
    case NULL:
    case TRUE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      Literal(context);
      break;
    default:
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public FunctorRef CastExpression(ParserContext context) throws ParseException {
    FunctorRef fn, cast;
    UnaryFunctorRef convert;
    jj_consume_token(LPAREN);
    cast = Type(context);
    jj_consume_token(63);
    fn = UnaryExpression(context);
      if (isClassReference(cast))
      {
          Class<?> type = (Class)((GeneratorRef) cast).getFunctor().fn();
          if (Number.class.isAssignableFrom(type)) {
              convert = new UnaryFunctorRef(new ValueOf(type).compose(new Cast(Number.class)),
                                            Object.class, "?", type);
          }
          else
              convert = new UnaryFunctorRef(new Cast(type), Object.class, "?", type);

          {if (true) return bindUnaryFn(convert, fn);}
      }
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef PrimaryExpression(ParserContext context) throws ParseException {
    FunctorRef fn;
    fn = PrimaryPrefix(context);
    label_13:
    while (true) {
      if (jj_2_6(2)) {
        ;
      } else {
        break label_13;
      }
      fn = PrimarySuffix(context, fn);
    }
    {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef PrimaryPrefix(ParserContext context) throws ParseException {
    FunctorRef fn, valueFn;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FALSE:
    case NULL:
    case TRUE:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
      fn = Literal(context);
      break;
    case THIS:
      jj_consume_token(THIS);
            Object thisObj = context.getBoundObject();
            if (thisObj == null) {
                String msg = "\u005c"this\u005c" has not been bound to any particular object";
                {if (true) throw new ParseException(msg);}
            }
            fn = new GeneratorRef(new Constant(thisObj), thisObj.getClass());
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
      fn = Expression(context);
      jj_consume_token(63);
      break;
    case NEW:
      jj_consume_token(NEW);
      fn = AllocationExpression(context);
      break;
    default:
      if (jj_2_7(2147483647)) {
        fn = ImportedStaticMethodCall(context);
      } else if (jj_2_8(2147483647)) {
        fn = PositionalArgument(context);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          fn = Name(context);
          break;
        default:
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef AllocationExpression(ParserContext context) throws ParseException {
    FunctorRef fn;
    FunctorRef[] args;
    //   LOOKAHEAD(2)
    //   "new" PrimitiveType(context) ArrayDimsAndInits(context)
    // |
       fn = Type(context);
    //     (
    //       ArrayDimsAndInits(context)
    //     |
       args = Arguments(context);
                               fn = resolveConstructor(fn, args);
      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Type(ParserContext context) throws ParseException {
    FunctorRef fn = null;
    StringBuffer buffer = new StringBuffer();
    Token t;
    t = jj_consume_token(IDENTIFIER);
        fn = resolveName(context, buffer, fn, t.image);
    label_14:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 65:
        ;
        break;
      default:
        break label_14;
      }
      jj_consume_token(65);
            buffer.append(".");
      t = jj_consume_token(IDENTIFIER);
                         fn = resolveName(context, buffer, fn, t.image);
    }
      if (fn == null) {
          String msg = "Unknown type \u005c"{0}\u005c"";
          {if (true) throw new ParseException(MessageFormat.format(msg, buffer));}
      }

      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

// /*
//  * The third LOOKAHEAD specification below is to parse to PrimarySuffix
//  * if there is an expression between the "[...]".
//  */
// void ArrayDimsAndInits(ParserContext context):
// {}
// {
//   LOOKAHEAD(2)
//   ( LOOKAHEAD(2) "[" Expression(context) "]" )+ ( LOOKAHEAD(2) "[" "]" )*
// |
//   ( "[" "]" )+ ArrayInitializer(context)
// }
  final public FunctorRef PrimarySuffix(ParserContext context, FunctorRef prefix) throws ParseException {
    FunctorRef fn;
    FunctorRef[] args;
    Token t;
    if (jj_2_9(2)) {
      jj_consume_token(65);
      jj_consume_token(CLASS);
          if (isClassReference(prefix)) {
              {if (true) return prefix;}
          }
          else {
              String msg = ".class may only be applied to constant class reference";
              {if (true) throw new ParseException(msg);}
          }
    } else if (jj_2_10(3)) {
      jj_consume_token(65);
      t = jj_consume_token(IDENTIFIER);
      args = Arguments(context);
        fn = resolveMethodName(prefix, t.image, args);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 65:
        jj_consume_token(65);
        t = jj_consume_token(IDENTIFIER);
          FunctorRef subFn = reservedField(prefix, t.image);
          fn = (subFn != null) ? subFn : resolveName(prefix, t.image);
        break;
      default:
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public void ImportedMethodLookahead(ParserContext context) throws ParseException {
    jj_consume_token(IDENTIFIER);
    jj_consume_token(LPAREN);
  }

  final public FunctorRef ImportedStaticMethodCall(ParserContext context) throws ParseException {
    FunctorRef fn = null;
    FunctorRef[] args;
    Token t;
    t = jj_consume_token(IDENTIFIER);
    args = Arguments(context);
         fn = resolveImportedMethod(context, t.image, args);
         if (fn == null)
             fn = reservedFunction(t.image, args);
      if (fn == null) {
          String msg = "Unable to parse \u005c"{0}\u005c" taking args {1}";
          {if (true) throw new ParseException(MessageFormat.format(msg, new Object[]{t.image, args}));}
      }

      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef PositionalArgument(ParserContext context) throws ParseException {
    FunctorRef fn = null, classref = null;
    Token t;
    jj_consume_token(64);
    t = jj_consume_token(INTEGER_LITERAL);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 41:
      jj_consume_token(41);
      classref = Type(context);
      break;
    default:
      ;
    }
    jj_consume_token(66);
        VariableRef<?> var = null;
        int idx = Integer.decode(t.image);
        if (classref != null) {
            if (!isClassReference(classref)) {
                String msg = "Unknown type {0}";
                {if (true) throw new ParseException(MessageFormat.format(msg, classref));}
            }

            var = context.resolvePosition(idx, getReferencedClass(classref));
        }
        else {
            var = context.resolvePosition(Integer.decode(t.image), context.getInferredType());
        }

        {if (true) return new GeneratorRef(var.accessor(), var.getType());}
      String msg = "Argument out of range: {0}";
      {if (true) throw new ParseException(MessageFormat.format(msg, new Object[]{t.image}));}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Name(ParserContext context) throws ParseException {
    FunctorRef fn = null;
    FunctorRef[] args;
    StringBuffer buffer = new StringBuffer();
    Token t;
    t = jj_consume_token(IDENTIFIER);
        VariableRef<?> var = context.resolveName(t.image);
        if (var != null)
            fn =  new GeneratorRef(var.accessor(), var.getType());

        Field field = context.getImportedField(t.image);
        if (field != null) {
            try {
               Generator gen = Modifier.isFinal(field.getModifiers())
                    ? new Constant(field.get(null))
                    : new GetField(field.getDeclaringClass(), field).bind(null);

               fn = new GeneratorRef(gen, field.getType());
            }
            catch (IllegalAccessException x) {
                {if (true) throw new ParseException(x.getMessage());}
            }
        }

        if (fn == null)
            fn = reservedWord(t.image);
        if (fn == null)
            fn = resolveName(context, buffer, fn, t.image);
    label_15:
    while (true) {
      if (jj_2_11(2147483647) && (getToken(3).kind != LPAREN)) {
        ;
      } else {
        break label_15;
      }
      jj_consume_token(65);
            buffer.append(".");
      t = jj_consume_token(IDENTIFIER);
          FunctorRef subFn = reservedField(fn, t.image);
          fn = (subFn != null) ? subFn : resolveName(context, buffer, fn, t.image);
    }
      if (fn == null) {
          String msg = "Unable to parse \u005c"{0}\u005c"";
          {if (true) throw new ParseException(MessageFormat.format(msg, buffer));}
//      	  VariableRef ref = context.declareArgument(t.image, Object.class);
//          return new GeneratorRef(ref.accessor(), Object.class);
      }

      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef[] Arguments(ParserContext context) throws ParseException {
    FunctorRef[] args = new FunctorRef[0];
    jj_consume_token(LPAREN);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case FALSE:
    case NEW:
    case NULL:
    case THIS:
    case TRUE:
    case LPAREN:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case CHARACTER_LITERAL:
    case STRING_LITERAL:
    case IDENTIFIER:
    case 56:
    case 57:
    case 61:
    case 62:
    case 64:
      args = ArgumentList(context, args);
      break;
    default:
      ;
    }
    jj_consume_token(63);
          {if (true) return args;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef[] ArgumentList(ParserContext context, FunctorRef[] args) throws ParseException {
    ArrayList argList = new ArrayList();
    FunctorRef fn;
    fn = Expression(context);
          argList.add(fn);
    label_16:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 27:
        ;
        break;
      default:
        break label_16;
      }
      jj_consume_token(27);
      fn = Expression(context);
            argList.add(fn);
    }
      {if (true) return (FunctorRef[]) argList.toArray(args);}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Literal(ParserContext context) throws ParseException {
    FunctorRef fn;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      fn = Integer();
      break;
    case FLOATING_POINT_LITERAL:
      fn = Float(context);
      break;
    case FALSE:
    case TRUE:
      fn = Boolean();
      break;
    case CHARACTER_LITERAL:
      fn = Character();
      break;
    case STRING_LITERAL:
      fn = String();
      break;
    case NULL:
      fn = Null();
      break;
    default:
      jj_consume_token(-1);
      throw new ParseException();
    }
      {if (true) return fn;}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Integer() throws ParseException {
                        Token t;
    t = jj_consume_token(INTEGER_LITERAL);
        // Based on the suffix, return either a Long or an Integer
        char suffix = t.image.charAt(t.image.length() - 1);
        if (suffix == 'L' || suffix == 'l') {
            String img = t.image.substring(0, t.image.length() - 1);
            {if (true) return new GeneratorRef(new Constant(Long.decode(img)), Long.class);}
        }

        {if (true) return new GeneratorRef(new Constant(Integer.decode(t.image)), Integer.class);}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Float(ParserContext context) throws ParseException {
                                           Token t;
    t = jj_consume_token(FLOATING_POINT_LITERAL);
        // Based on the suffix, return either a Float or a Double, or possibly a BigDecimal
        // if the 'isUndecoratedDecimal' flag is set
        String img = t.image;
        char suffix = img.charAt(t.image.length() - 1);
        if (suffix == 'F' || suffix == 'f') {
            img = img.substring(0, t.image.length() - 1);
            {if (true) return new GeneratorRef(new Constant(new Float(img)), Float.class);}
        }

        if (suffix == 'D' || suffix == 'd') {
            img = img.substring(0, t.image.length() - 1);
            {if (true) return new GeneratorRef(new Constant(new Double(t.image)), Double.class);}
        }

        if (context.isUndecoratedDecimal())
            {if (true) return new GeneratorRef(new Constant(new BigDecimal(t.image)), BigDecimal.class);}
        else
            {if (true) return new GeneratorRef(new Constant(new Double(t.image)), Double.class);}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Boolean() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
              {if (true) return new GeneratorRef(new Constant(Boolean.TRUE), Boolean.class);}
      break;
    case FALSE:
      jj_consume_token(FALSE);
              {if (true) return new GeneratorRef(new Constant(Boolean.FALSE),Boolean.class);}
      break;
    default:
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Character() throws ParseException {
                          Token t;
    t = jj_consume_token(CHARACTER_LITERAL);
            String contents = t.image.substring(1, t.image.length() - 1);
            StringBuffer buffer = new StringBuffer(contents);
            Character c = decodeChar(buffer);
            if (buffer.length() != 0)
                {if (true) throw new ParseException("Unknown character "+t.image);}

            {if (true) return new GeneratorRef(new Constant(c), Character.class);}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef String() throws ParseException {
                       Token t;
    t = jj_consume_token(STRING_LITERAL);
            String contents = t.image.substring(1, t.image.length() - 1);
            StringBuffer buffer = new StringBuffer(contents);
            StringBuffer value = new StringBuffer(contents.length());
            while (buffer.length() > 0) {
                value.append(decodeChar(buffer).charValue());
            }

            {if (true) return new GeneratorRef(new Constant(value.toString()),String.class);}
    throw new Error("Missing return statement in function");
  }

  final public FunctorRef Null() throws ParseException {
    jj_consume_token(NULL);
              {if (true) return new GeneratorRef(new Constant(null), Object.class);}
    throw new Error("Missing return statement in function");
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
  }

  private boolean jj_3R_127() {
    if (jj_scan_token(60)) return true;
    return false;
  }

  private boolean jj_3R_111() {
    if (jj_scan_token(52)) return true;
    return false;
  }

  private boolean jj_3R_126() {
    if (jj_scan_token(59)) return true;
    return false;
  }

  private boolean jj_3R_110() {
    if (jj_scan_token(51)) return true;
    return false;
  }

  private boolean jj_3R_18() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_29()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_48() {
    if (jj_3R_57()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_82()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_125() {
    if (jj_scan_token(58)) return true;
    return false;
  }

  private boolean jj_3R_109() {
    if (jj_scan_token(50)) return true;
    return false;
  }

  private boolean jj_3R_122() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_125()) {
    jj_scanpos = xsp;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) return true;
    }
    }
    if (jj_3R_103()) return true;
    return false;
  }

  private boolean jj_3R_108() {
    if (jj_scan_token(49)) return true;
    return false;
  }

  private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) {
    jj_scanpos = xsp;
    if (jj_3R_111()) return true;
    }
    }
    }
    if (jj_3R_95()) return true;
    return false;
  }

  private boolean jj_3R_42() {
    if (jj_scan_token(39)) return true;
    return false;
  }

  private boolean jj_3R_41() {
    if (jj_scan_token(38)) return true;
    return false;
  }

  private boolean jj_3R_40() {
    if (jj_scan_token(37)) return true;
    return false;
  }

  private boolean jj_3R_39() {
    if (jj_scan_token(36)) return true;
    return false;
  }

  private boolean jj_3R_38() {
    if (jj_scan_token(35)) return true;
    return false;
  }

  private boolean jj_3R_99() {
    if (jj_3R_103()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_122()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_37() {
    if (jj_scan_token(34)) return true;
    return false;
  }

  private boolean jj_3R_93() {
    if (jj_3R_95()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_104()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_36() {
    if (jj_scan_token(33)) return true;
    return false;
  }

  private boolean jj_3R_35() {
    if (jj_scan_token(32)) return true;
    return false;
  }

  private boolean jj_3R_34() {
    if (jj_scan_token(31)) return true;
    return false;
  }

  private boolean jj_3R_33() {
    if (jj_scan_token(30)) return true;
    return false;
  }

  private boolean jj_3R_32() {
    if (jj_scan_token(29)) return true;
    return false;
  }

  private boolean jj_3R_31() {
    if (jj_scan_token(28)) return true;
    return false;
  }

  private boolean jj_3_8() {
    if (jj_scan_token(64)) return true;
    return false;
  }

  private boolean jj_3R_58() {
    if (jj_3R_18()) return true;
    if (jj_3R_25()) return true;
    return false;
  }

  private boolean jj_3R_61() {
    if (jj_scan_token(IDENTIFIER)) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_70()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_7() {
    if (jj_3R_24()) return true;
    return false;
  }

  private boolean jj_3R_20() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_31()) {
    jj_scanpos = xsp;
    if (jj_3R_32()) {
    jj_scanpos = xsp;
    if (jj_3R_33()) {
    jj_scanpos = xsp;
    if (jj_3R_34()) {
    jj_scanpos = xsp;
    if (jj_3R_35()) {
    jj_scanpos = xsp;
    if (jj_3R_36()) {
    jj_scanpos = xsp;
    if (jj_3R_37()) {
    jj_scanpos = xsp;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) {
    jj_scanpos = xsp;
    if (jj_3R_41()) {
    jj_scanpos = xsp;
    if (jj_3R_42()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_44() {
    if (jj_3R_56()) return true;
    return false;
  }

  private boolean jj_3R_55() {
    if (jj_3R_61()) return true;
    return false;
  }

  private boolean jj_3R_54() {
    if (jj_3R_60()) return true;
    return false;
  }

  private boolean jj_3R_76() {
    if (jj_scan_token(NULL)) return true;
    return false;
  }

  private boolean jj_3R_100() {
    if (jj_scan_token(INSTANCEOF)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  private boolean jj_3R_53() {
    if (jj_3R_59()) return true;
    return false;
  }

  private boolean jj_3R_52() {
    if (jj_scan_token(NEW)) return true;
    if (jj_3R_58()) return true;
    return false;
  }

  private boolean jj_3R_91() {
    if (jj_3R_93()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_100()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3R_51() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_17()) return true;
    if (jj_scan_token(63)) return true;
    return false;
  }

  private boolean jj_3R_102() {
    if (jj_scan_token(48)) return true;
    return false;
  }

  private boolean jj_3R_47() {
    if (jj_3R_19()) return true;
    if (jj_3R_20()) return true;
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_75() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_50() {
    if (jj_scan_token(THIS)) return true;
    return false;
  }

  private boolean jj_3R_101() {
    if (jj_scan_token(47)) return true;
    return false;
  }

  private boolean jj_3R_49() {
    if (jj_3R_56()) return true;
    return false;
  }

  private boolean jj_3R_69() {
    if (jj_scan_token(41)) return true;
    if (jj_3R_18()) return true;
    return false;
  }

  private boolean jj_3R_98() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_101()) {
    jj_scanpos = xsp;
    if (jj_3R_102()) return true;
    }
    if (jj_3R_91()) return true;
    return false;
  }

  private boolean jj_3R_30() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_49()) {
    jj_scanpos = xsp;
    if (jj_3R_50()) {
    jj_scanpos = xsp;
    if (jj_3R_51()) {
    jj_scanpos = xsp;
    if (jj_3R_52()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) {
    jj_scanpos = xsp;
    if (jj_3R_54()) {
    jj_scanpos = xsp;
    if (jj_3R_55()) return true;
    }
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_88() {
    if (jj_3R_91()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_98()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_60() {
    if (jj_scan_token(64)) return true;
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_69()) jj_scanpos = xsp;
    if (jj_scan_token(66)) return true;
    return false;
  }

  private boolean jj_3_6() {
    if (jj_3R_23()) return true;
    return false;
  }

  private boolean jj_3R_74() {
    if (jj_scan_token(CHARACTER_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_89() {
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3R_19() {
    if (jj_3R_30()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_6()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_80() {
    if (jj_scan_token(FALSE)) return true;
    return false;
  }

  private boolean jj_3R_79() {
    if (jj_scan_token(TRUE)) return true;
    return false;
  }

  private boolean jj_3R_73() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_79()) {
    jj_scanpos = xsp;
    if (jj_3R_80()) return true;
    }
    return false;
  }

  private boolean jj_3R_96() {
    if (jj_scan_token(46)) return true;
    if (jj_3R_88()) return true;
    return false;
  }

  private boolean jj_3R_84() {
    if (jj_3R_88()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_96()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_59() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_3R_25()) return true;
    return false;
  }

  private boolean jj_3R_43() {
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_112() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_18()) return true;
    if (jj_scan_token(63)) return true;
    if (jj_3R_103()) return true;
    return false;
  }

  private boolean jj_3R_24() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_scan_token(LPAREN)) return true;
    return false;
  }

  private boolean jj_3R_72() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_94() {
    if (jj_scan_token(45)) return true;
    if (jj_3R_84()) return true;
    return false;
  }

  private boolean jj_3R_22() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_3R_18()) return true;
    if (jj_scan_token(63)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_scan_token(62)) {
    jj_scanpos = xsp;
    if (jj_scan_token(14)) {
    jj_scanpos = xsp;
    if (jj_scan_token(23)) {
    jj_scanpos = xsp;
    if (jj_scan_token(12)) {
    jj_scanpos = xsp;
    if (jj_scan_token(10)) {
    jj_scanpos = xsp;
    if (jj_3R_44()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_85() {
    if (jj_scan_token(28)) return true;
    if (jj_3R_89()) return true;
    return false;
  }

  private boolean jj_3R_81() {
    if (jj_3R_84()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_94()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_21() {
    if (jj_3R_43()) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_85()) jj_scanpos = xsp;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_scan_token(27)) return true;
    if (jj_3R_21()) return true;
    return false;
  }

  private boolean jj_3R_124() {
    if (jj_scan_token(57)) return true;
    return false;
  }

  private boolean jj_3R_45() {
    if (jj_scan_token(65)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_71() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    return false;
  }

  private boolean jj_3R_67() {
    if (jj_3R_76()) return true;
    return false;
  }

  private boolean jj_3R_66() {
    if (jj_3R_75()) return true;
    return false;
  }

  private boolean jj_3R_65() {
    if (jj_3R_74()) return true;
    return false;
  }

  private boolean jj_3R_64() {
    if (jj_3R_73()) return true;
    return false;
  }

  private boolean jj_3_10() {
    if (jj_scan_token(65)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_3R_25()) return true;
    return false;
  }

  private boolean jj_3R_63() {
    if (jj_3R_72()) return true;
    return false;
  }

  private boolean jj_3R_62() {
    if (jj_3R_71()) return true;
    return false;
  }

  private boolean jj_3R_92() {
    if (jj_scan_token(44)) return true;
    if (jj_3R_81()) return true;
    return false;
  }

  private boolean jj_3R_56() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_62()) {
    jj_scanpos = xsp;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) {
    jj_scanpos = xsp;
    if (jj_3R_65()) {
    jj_scanpos = xsp;
    if (jj_3R_66()) {
    jj_scanpos = xsp;
    if (jj_3R_67()) return true;
    }
    }
    }
    }
    }
    return false;
  }

  private boolean jj_3R_123() {
    if (jj_scan_token(56)) return true;
    return false;
  }

  private boolean jj_3R_114() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_123()) {
    jj_scanpos = xsp;
    if (jj_3R_124()) return true;
    }
    if (jj_3R_99()) return true;
    return false;
  }

  private boolean jj_3R_46() {
    if (jj_3R_18()) return true;
    if (jj_3R_21()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_4()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_77() {
    if (jj_3R_81()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_92()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_3() {
    if (jj_3R_19()) return true;
    if (jj_3R_20()) return true;
    return false;
  }

  private boolean jj_3R_97() {
    if (jj_3R_99()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_114()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_87() {
    if (jj_scan_token(27)) return true;
    if (jj_3R_17()) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_3R_18()) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_90() {
    if (jj_scan_token(43)) return true;
    if (jj_3R_77()) return true;
    return false;
  }

  private boolean jj_3R_28() {
    if (jj_3R_48()) return true;
    return false;
  }

  private boolean jj_3_9() {
    if (jj_scan_token(65)) return true;
    if (jj_scan_token(CLASS)) return true;
    return false;
  }

  private boolean jj_3R_27() {
    if (jj_3R_47()) return true;
    return false;
  }

  private boolean jj_3R_83() {
    if (jj_3R_17()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_87()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_23() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3R_45()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_26() {
    if (jj_3R_46()) return true;
    return false;
  }

  private boolean jj_3R_78() {
    if (jj_3R_83()) return true;
    return false;
  }

  private boolean jj_3R_68() {
    if (jj_3R_77()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_90()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_121() {
    if (jj_scan_token(62)) return true;
    return false;
  }

  private boolean jj_3R_120() {
    if (jj_scan_token(61)) return true;
    return false;
  }

  private boolean jj_3R_119() {
    if (jj_scan_token(56)) return true;
    return false;
  }

  private boolean jj_3R_17() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_26()) {
    jj_scanpos = xsp;
    if (jj_3R_27()) {
    jj_scanpos = xsp;
    if (jj_3R_28()) return true;
    }
    }
    return false;
  }

  private boolean jj_3R_118() {
    if (jj_scan_token(57)) return true;
    return false;
  }

  private boolean jj_3R_113() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_118()) {
    jj_scanpos = xsp;
    if (jj_3R_119()) {
    jj_scanpos = xsp;
    if (jj_3R_120()) {
    jj_scanpos = xsp;
    if (jj_3R_121()) return true;
    }
    }
    }
    return false;
  }

  private boolean jj_3_5() {
    if (jj_3R_22()) return true;
    return false;
  }

  private boolean jj_3R_25() {
    if (jj_scan_token(LPAREN)) return true;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_78()) jj_scanpos = xsp;
    if (jj_scan_token(63)) return true;
    return false;
  }

  private boolean jj_3R_86() {
    if (jj_scan_token(42)) return true;
    if (jj_3R_68()) return true;
    return false;
  }

  private boolean jj_3R_107() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_115()) {
    jj_scanpos = xsp;
    if (jj_3R_116()) {
    jj_scanpos = xsp;
    if (jj_3R_117()) return true;
    }
    }
    if (jj_3R_97()) return true;
    return false;
  }

  private boolean jj_3R_117() {
    if (jj_scan_token(55)) return true;
    return false;
  }

  private boolean jj_3R_116() {
    if (jj_scan_token(54)) return true;
    return false;
  }

  private boolean jj_3R_115() {
    if (jj_scan_token(53)) return true;
    return false;
  }

  private boolean jj_3R_106() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_113()) jj_scanpos = xsp;
    if (jj_3R_19()) return true;
    return false;
  }

  private boolean jj_3_1() {
    if (jj_scan_token(26)) return true;
    if (jj_3R_17()) return true;
    return false;
  }

  private boolean jj_3R_105() {
    if (jj_3R_112()) return true;
    return false;
  }

  private boolean jj_3R_103() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_105()) {
    jj_scanpos = xsp;
    if (jj_3R_106()) return true;
    }
    return false;
  }

  private boolean jj_3R_57() {
    if (jj_3R_68()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_86()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3_11() {
    if (jj_scan_token(65)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_95() {
    if (jj_3R_97()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_107()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  private boolean jj_3R_29() {
    if (jj_scan_token(65)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_70() {
    if (jj_scan_token(65)) return true;
    if (jj_scan_token(IDENTIFIER)) return true;
    return false;
  }

  private boolean jj_3R_82() {
    if (jj_scan_token(40)) return true;
    if (jj_3R_17()) return true;
    if (jj_scan_token(41)) return true;
    if (jj_3R_17()) return true;
    return false;
  }

  /** Generated Token Manager. */
  public JFXGParserTokenManager token_source;
  JavaCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;

  /** Constructor with InputStream. */
  public JFXGParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public JFXGParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new JavaCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new JFXGParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  /** Constructor. */
  public JFXGParser(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new JFXGParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
  }

  /** Constructor with generated Token Manager. */
  public JFXGParser(JFXGParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
  }

  /** Reinitialise. */
  public void ReInit(JFXGParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      return token;
    }
    token = oldToken;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    Token errortok = token.next;
    int line = errortok.beginLine, column = errortok.beginColumn;
    String mess = (errortok.kind == 0) ? tokenImage[0] : errortok.image;
    return new ParseException("Parse error at line " + line + ", column " + column + ".  Encountered: " + mess);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

}
