// ============================================================================
// $Id: JavaLangResources.java,v 1.5 2009/01/19 03:37:21 davidahall Exp $
// Copyright (c) 2004-2005  David A. Hall
// ============================================================================
// The contents of this file are subject to the Common Development and
// Distribution License (CDDL), Version 1.0 (the License); you may not use this 
// file except in compliance with the License.  You should have received a copy
// of the the License along with this file: if not, a copy of the License is 
// available from Sun Microsystems, Inc.
//
// http://www.sun.com/cddl/cddl.html
//
// From time to time, the license steward (initially Sun Microsystems, Inc.) may
// publish revised and/or new versions of the License.  You may not use,  
// distribute, or otherwise make this file available under subsequent versions 
// of the License.
// 
// Alternatively, the contents of this file may be used under the terms of the 
// GNU Lesser General Public License Version 2.1 or later (the "LGPL"), in which
// case the provisions of the LGPL are applicable instead of those above. If you 
// wish to allow use of your version of this file only under the terms of the 
// LGPL, and not to allow others to use your version of this file under the 
// terms of the CDDL, indicate your decision by deleting the provisions above 
// and replace them with the notice and other provisions required by the LGPL. 
// If you do not delete the provisions above, a recipient may use your version 
// of this file under the terms of either the CDDL or the LGPL.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// ============================================================================

package net.sf.jga.parser;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

/**
 * JavaLangResources.java
 *
 * <p>
 * Copyright &copy; 2004-2005  David A. Hall
 * @author <a href="mailto:davidahall@users.sf.net">David A. Hall</a>
 */

class JavaLangResources {
    static private Map<String,Class<?>> classMap = new HashMap<String,Class<?>>();
    static public Map<String,Class<?>> getMap() { return Collections.unmodifiableMap(classMap); }
    static {
        classMap.put("Boolean",Boolean.class);
        classMap.put("Byte",Byte.class);
        classMap.put("Character",Character.class);
        classMap.put("Character.Subset",Character.Subset.class);
        classMap.put("Character.UnicodeBlock",Character.UnicodeBlock.class);
        classMap.put("Class",Class.class);
//         classMap.put("ClassLoader",ClassLoader.class);
        classMap.put("Compiler",Compiler.class);
        classMap.put("Double",Double.class);
        classMap.put("Float",Float.class);
        classMap.put("InheritableThreadLocal",InheritableThreadLocal.class);
        classMap.put("Integer",Integer.class);
        classMap.put("Long",Long.class);
        classMap.put("Math",Math.class);
        classMap.put("Number",Number.class);
        classMap.put("Object",Object.class);
        classMap.put("Package",Package.class);
        classMap.put("Process",Process.class);
        classMap.put("Runtime",Runtime.class);
//         classMap.put("RuntimePermission",RuntimePermission.class);
//         classMap.put("SecurityManager",SecurityManager.class);
        classMap.put("Short",Short.class);
        classMap.put("StackTraceElement",StackTraceElement.class);
        classMap.put("StrictMath",StrictMath.class);
        classMap.put("String",String.class);
        classMap.put("StringBuffer",StringBuffer.class);
        classMap.put("System",System.class);
        classMap.put("Thread",Thread.class);
        classMap.put("ThreadGroup",ThreadGroup.class);
        classMap.put("ThreadLocal",ThreadLocal.class);
        classMap.put("Throwable",Throwable.class);
        classMap.put("Void",Void.class);
    }
}
