package net.sf.jga.parser;

import java.lang.reflect.Field;

import net.sf.jga.fn.property.SetField;

/**
 * Similar to the standard SetField functor, except that the fn() method returns the value passed
 * rather than null
 * @author dave
 *
 * @param <T>
 * @param <V>
 */
public class SetAndReturnField<T, V> extends SetField<T, V> {
    private static final long serialVersionUID = 652969504255872695L;

    public SetAndReturnField(Field field) {
        super(field);
    }

    public SetAndReturnField(Class<T> argType, Field field) {
        super(argType, field);
    }

    public SetAndReturnField(Class<T> argType, Field field, Class<V> fieldType) {
        super(argType, field, fieldType);
    }

    public SetAndReturnField(Class<T> argType, String fieldName, Class<V> fieldType) {
        super(argType, fieldName, fieldType);
    }

    public V fn(T obj, V value) {
        super.fn(obj, value);
        return value;
    }
}
