package net.sf.jga.parser;

import net.sf.jga.fn.Functor;
import net.sf.jga.fn.adaptor.Constant;
import net.sf.jga.fn.adaptor.Identity;
import net.sf.jga.parser.FunctorRef;

public class VariableFunctorRef<R,F extends Functor<R>> implements FunctorRef<R,F> {

    private F fn;
    private Class<R> type; 
    private VariableRef<?>[] args;
    
    public VariableFunctorRef(F fn, Class<R> type, VariableRef<?>[] args) {
        this.fn = fn;
        this.type = type;
        this.args = args;
    }

    public F getFunctor() {
        return fn;
    }

    public Class<R> getReturnType() {
        return type;
    }

    public int getNumberArgs() {
        return args.length;
    }

    public Class<?> getArgType(int i) {
        return args[i].getType();
    }

    public String getArgName(int i) {
        return args[i].getName();
    }

    public boolean isConstant() {
        return fn instanceof Constant; 
    }
    
    public boolean isIdentity() {
        return fn instanceof Identity; 
    }
}
