// ============================================================================
// $Id: VariableRef.java,v 1.3 2009/09/06 22:28:37 davidahall Exp $
// Copyright (c) 2004-2005  David A. Hall
// ============================================================================
// The contents of this file are subject to the Common Development and
// Distribution License (CDDL), Version 1.0 (the License); you may not use this 
// file except in compliance with the License.  You should have received a copy
// of the the License along with this file: if not, a copy of the License is 
// available from Sun Microsystems, Inc.
//
// http://www.sun.com/cddl/cddl.html
//
// From time to time, the license steward (initially Sun Microsystems, Inc.) may
// publish revised and/or new versions of the License.  You may not use,  
// distribute, or otherwise make this file available under subsequent versions 
// of the License.
// 
// Alternatively, the contents of this file may be used under the terms of the 
// GNU Lesser General Public License Version 2.1 or later (the "LGPL"), in which
// case the provisions of the LGPL are applicable instead of those above. If you 
// wish to allow use of your version of this file only under the terms of the 
// LGPL, and not to allow others to use your version of this file under the 
// terms of the CDDL, indicate your decision by deleting the provisions above 
// and replace them with the notice and other provisions required by the LGPL. 
// If you do not delete the provisions above, a recipient may use your version 
// of this file under the terms of either the CDDL or the LGPL.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// ============================================================================

package net.sf.jga.parser;

import net.sf.jga.fn.Generator;
import net.sf.jga.fn.UnaryFunctor;
import net.sf.jga.fn.adaptor.Identity;

public class VariableRef<T> {
    
    static public final VariableRef<Object> UNDECLARED = 
        new VariableRef<Object>("UNDECLARED", Object.class);
    
    public VariableRef(String name, Class<T> type) {
        this.name = name;
        this.type = type;
    }
    
    private Identity<T> store = new Identity<T>();
    public UnaryFunctor<T,T> mutator() { return store; }

    private Generator<T> accessor = store.accessor();
    public Generator<T> accessor() { return accessor; }
    
    private String name;
    public String getName() { return name; }
    
    private Class<T> type;
    public Class<T> getType() { return type; }
}

